FrameworkApp.directive('lastpage', function () {
	return {
		restrict: 'C',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope, $timeout) {
			$rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] = "1";
			$rootScope.isLastPage = true;
			$timeout(function () {
				$rootScope.isNextButtonDisabled = true;
			});


			$scope.certificate = true;
			$scope.commitment = false;
			$scope.togglePage = function () {
				if ($scope.certificate) {
					$scope.certificate = false;
					$scope.commitment = true;
				} else {
					$scope.certificate = true;
					$scope.commitment = false;
				}
			};
			$rootScope.assesmentPercentageScore = Math.round(($rootScope.assesmentScore / $rootScope.CourseConfig.AvailableAssessmentQuestion) * 100);
		}
	}
});

FrameworkApp.directive('dragdropmany1', function ($rootScope, $timeout) {
	return {
		restrict: 'AE',
		scope: {},
		template: '<ng-include src="getTemplateUrl()"/>',
		link: function (scope, elem, attrs) {
			scope.getTemplateUrl = function () {
				return '../html5/Views/kc/' + template + '.html';
			};
			var template = attrs.templateUrl;
			var correctAnswer = [];
			var submitEnable = 0;
			var showAnswer = 2;
			var noOfDragable = 0;
			//console.log($rootScope.CourseContent)
			var showMarkerInAttempt = 1;
			var option = [];
			var totalCorrectAns = 0;
			var curretAttempt = 1;
			var maxDropItem;
			var maxAttempt;
			var dragOpts = {
				cursor: 'move',
				zIndex: 99999
			};

			var correctFeedback = $rootScope.CourseContent.correct_feedback;
			var pertialFeedback = $rootScope.CourseContent.try_feedback;
			var incorrectFeedback = $rootScope.CourseContent.incorrect_feedback;

			scope.feedbackToggle = false;
			scope.buttonText = $rootScope.CourseContent.submitText;
			scope.buttonResetText = $rootScope.CourseContent.resetText;
			scope.instruction_text = $rootScope.CourseContent.instruction_text;
			scope.showAnsText = $rootScope.CourseContent.showAns;
			scope.myAnsText = $rootScope.CourseContent.myAns;
			maxAttempt = $rootScope.CourseContent.maximumAttempt;
			scope.feedback = "";
			scope.question = $rootScope.CourseContent.question;
			scope.options = $rootScope.CourseContent.options;
			scope.maxDropItem = Number($rootScope.CourseContent.maxDropItem);
			scope.userAnswer = [];
			scope.disableButton = true;
			scope.showAnser = false;
			scope.myAnswer = false;
			scope.failed = false;

			if (attrs.assesment == "true") {
				$rootScope.isPrevButtonDisabled = true;
			}
			var incHeight = 77;
			var currentHeightM1 = 0;
			var currentHeightM2 = 0;
			var currentHeight = 0;
			scope.start = function () {
				noOfDragable = $rootScope.CourseContent.options.length;
				$rootScope.disableBackBtn = true;
				for (var i = 1; i <= noOfDragable; i++) {
					option.push("#draggable_" + i) // Number of draggable obbjects 
				}

				for (var i = 1; i <= noOfDragable; i++) {
					correctAnswer.push($rootScope.CourseContent.options[i - 1].dropIndex);
					$("#target_" + i).data("id", 0);
					$("#draggable_" + i).data("id", 0);
					$("#draggable_" + i).data({
						'originalLeft': $("#draggable_" + i).css('left'),
						'origionalTop': $("#draggable_" + i).css('top')
					});
					$("#draggable_" + i).draggable(dragOpts);
					$("#draggable_" + i).draggable({
						drag: function () {
							$(this).css({ cursor: 'move', zIndex: 99999 });
							$(this).find('p').addClass('onDrag')
							var drag_id = $(this).data("id");
							//console.log("drag_id "+drag_id)
							$('#cart_' + drag_id).css('overflow', 'visible')
						},
						revert: function (Obj) {
							if (Obj == false) {
								var dragedId = this.attr("id").split("_")[1];
								var targetId = $("#draggable_" + dragedId).data("id")
								this.appendTo("#dragarea_" + dragedId);
								$("#draggable_" + dragedId).find('p').removeClass('afterDrag onDrag');
								$("#target_" + targetId).droppable("enable");
								// Toggle drag indicator
								if ($('#cart_' + targetId).children().length == 1)
									$("#cart_" + targetId).find('.cart').css('display', 'none');

								this.css({ top: 0, left: 0 });
								$("#draggable_" + dragedId).data("id", 0);
								checkSubmitEnable();
								scope.showOption(dragedId); // Shows the next draggable object

							}
							//$('.Caart').css('overflow','hidden')
							checkSubmitEnable();
						}
					});

					$("#target_" + i).droppable
						({
							accept: option.toString(),
							drop: function (event, ui) {
								var dragedId = parseInt(ui.draggable.attr("id").split("_")[1]);
								var targetId = event.target.id.split("_")[1];

								// $('.Caart').css('overflow','hidden')
								if ($('#cart_' + targetId).children().length == scope.maxDropItem + 1) {
									$("#draggable_" + dragedId).appendTo("#dragarea_" + dragedId);
									$("#draggable_" + dragedId).css({ '': '', 'left': '0px', 'margin': '0px' })
									$("#target_" + targetId).droppable("enable");
									$("#draggable_" + dragedId).find('p').removeClass('afterDrag onDrag');
									scope.showOption(dragedId + 1);
									$("#draggable_" + dragedId).data("id", 0);
									return true;
								}

								$("#target_" + targetId).droppable("enable");
								$("#draggable_" + dragedId).data("id", $(this).attr("id").split("_")[1]);
								$(this).data("id", targetId); // set the dragged object's id to target object
								$(ui.draggable).find('p').removeClass('onDrag').addClass('afterDrag');
								$("#cart_" + targetId).find('.cart').css('display', 'block'); // Toggle drag indicator
								var children = $('#cart_' + targetId).children().length;
								$(ui.draggable).appendTo($("#cart_" + targetId))
									// .css({ 'display':'inline-block' ,'top':function(){
									// 	if(parseInt(targetId)%2==0)
									// 		return currentHeightM1;
									// 	else
									// 		return currentHeightM2;
									// }, 'position':'absolute', 'margin':'1px 0px 1px 1px', 'left':'0px'}) 

									.css({ 'display': 'inline-block', 'width': 'auto', 'top': '0px', 'margin': '0px 5px 5px 5px', 'left': '0px' })// Custom CSS for dragged object
									.draggable('option', 'disabled', true);
								currentHeight = 0;
								if (parseInt(targetId) % 2 == 0) {
									currentHeightM1 += $(ui.draggable).height() + 2;
									currentHeight = currentHeightM1 + 2;
								} else {
									currentHeightM2 += $(ui.draggable).height() + 2;
									currentHeight = currentHeightM2 + 2;
								}
								if (submitEnable == 0)
									checkSubmitEnable();
								$(".btn-reset").attr("disabled", false);
								scope.showOption(dragedId + 1);
								$(ui.draggable).draggable('disable');
							}
						});
				}
				totalCorrectAns = correctAnswer.length;
				scope.showOption(1);
			}

			scope.showOption = function (id) {
				var cnt = 0;
				for (var i = 1; i <= noOfDragable; i++) {
					if ($("#draggable_" + i).data("id") == 0) {
						$('#dragHolder_' + i).show();
						return true;
					}
				}
			}

			scope.onResetClick = function () {
				currentHeightM1 = 0;
				currentHeightM2 = 0;
				currentHeight = 0;
				$rootScope.checkInternet($rootScope.selectedLang);
				for (var i = 1; i <= noOfDragable; i++) {
					$("#draggable_" + i).appendTo("#dragarea_" + i);
					$("#draggable_" + i).animate({ top: 0, left: 0 }, { duration: 600, easing: 'easeOutBack' });
					$("#target_" + i).removeClass('redBorder').removeClass('greenBorder');
					$("#target_" + i).droppable("enable");
					$("#target_" + i).data("id", 0);
					$("#draggable_" + i).data("id", 0);
					$("#draggable_" + i).draggable('option', 'disabled', false);
					$("#draggable_" + i).find('p').removeClass('afterDrag onDrag');
				}
				$("#cart_1 ,#cart_2, #cart_3, #cart_4").find('.cart').css('display', 'none');
				scope.showOption(1);
				if (submitEnable == 0)
					$(".btn-submit").attr("disabled", true);
				$(".btn-reset").attr("disabled", true);
				$('.drag-content').css('margin', 0);
				$('.drag-content').draggable('enable');
			}
			scope.onResetClick();

			scope.onShowAnsClick = function () {

				var currentHeight1 = 0;
				var currentHeight2 = 0;
				$rootScope.checkInternet($rootScope.selectedLang);
				//scope.showAnser= false;
				//scope.feedbackToggle = false;
				$(".next img").addClass("done");
				$rootScope.isNextButtonDisabled = false;
				if (scope.showAnsText == $rootScope.CourseContent.showAns) {
					for (var i = 1; i <= noOfDragable; i++) {
						$("#draggable_" + i).appendTo("#cart_" + correctAnswer[i - 1]);
						$("#draggable_" + i).addClass('greenBorder').removeClass('redBorder');
					}
					$(".Caart").each(function (ind, ele) {
						$(ele).find(".ui-draggable").each(function (_ind, _ele) {
							var _cElmId = $(_ele).attr('id');
							if (ind % 2 == 0) {
								$(_ele).css('top', '0px');
								currentHeight1 += $(_ele).height() + 2;
							} else {
								$(_ele).css('top', '0px');
								currentHeight2 += $(_ele).height() + 2;
							}

						});
					});
					scope.showAnsText = $rootScope.CourseContent.myAns;

				}
				else {
					scope.onMyAnsClick();

					scope.showAnsText = $rootScope.CourseContent.showAns;
				}
				scope.myAnswer = true;
			}

			scope.onMyAnsClick = function () {
				var currentHeight1 = 0;
				var currentHeight2 = 0;
				$rootScope.checkInternet($rootScope.selectedLang);
				$(".droppable-item").removeClass('greenBorder');
				for (var i = 1; i <= noOfDragable; i++) {
					var targetId = $("#draggable_" + i).data("id");
					$("#draggable_" + i).appendTo("#cart_" + targetId);

					if ($("#draggable_" + i).data("id") == correctAnswer[i - 1])
						$("#draggable_" + i).addClass('greenBorder').removeClass('redBorder');
					else if ($("#draggable_" + i).data("id") == $rootScope.CourseContent.options[i - 1].optional)
						$("#draggable_" + i).addClass('greenBorder').removeClass('redBorder');
					else
						$("#draggable_" + i).addClass('redBorder').removeClass('greenBorder');
				}
				$(".Caart").each(function (ind, ele) {
					$(ele).find(".ui-draggable").each(function (_ind, _ele) {
						if (ind % 2 == 0) {
							$(_ele).css('top', '0px');
							currentHeight1 += $(_ele).height() + 2;
						} else {
							$(_ele).css('top', '0px');
							currentHeight2 += $(_ele).height() + 2;
						}
					});
				});
				scope.myAnswer = false;
			}

			function checkSubmitEnable() {
				if (isSubmitBtnEnable())
					$(".btn-submit").attr("disabled", false);
				else
					$(".btn-submit").attr("disabled", true);
			}

			function isSubmitBtnEnable() {
				var cnt = 0;
				for (var i = 1; i <= noOfDragable; i++)
					if ($("#draggable_" + i).data("id") != 0)
						cnt++;
				if (cnt == 0)
					$(".btn-reset").attr("disabled", true);

				if (cnt == noOfDragable) {
					return true;
				} else {
					return false;
				}

			}

			scope.onSubmitClick = function () {

				$rootScope.checkInternet($rootScope.selectedLang);
				if (scope.buttonText == $rootScope.CourseContent.submitText) {
					$(".btn-reset").attr("disabled", true);
					var correctAns = 0;
					var inCorrectAns = 0;
					disableOption();
					if (attrs.feedback == "true")
						scope.feedbackToggle = true;
					for (var i = 1; i <= noOfDragable; i++) {
						$("#draggable_" + i).draggable('disable')
						if ($("#draggable_" + i).data("id") == correctAnswer[i - 1]) {
							if (showMarkerInAttempt == curretAttempt || showMarkerInAttempt == 0)
								$("#draggable_" + i).addClass('greenBorder');
							correctAns++;
						} else if ($("#draggable_" + i).data("id") == $rootScope.CourseContent.options[i - 1].optional) {
							if (showMarkerInAttempt == curretAttempt || showMarkerInAttempt == 0)
								$("#draggable_" + i).addClass('greenBorder');
							correctAns++;
						} else {
							inCorrectAns++;
							if (showMarkerInAttempt == curretAttempt || showMarkerInAttempt == 0)
								$("#draggable_" + i).addClass('redBorder');
						}
					}
					if (correctAns == totalCorrectAns && inCorrectAns == 0) {
						if (attrs.assesment == "true") {
							$rootScope.assesmentScore++;
							$rootScope.asmntScoreArray[$rootScope.quizCounter - 1] = 1;
							$rootScope.isAnswered = true;
						}
						$(".btn-submit").attr("disabled", true);
						feedbackSetText(correctFeedback);
						showCorrectAns();
						$(".next img").addClass("done");
						$rootScope.isNextButtonDisabled = false;
						$rootScope.markVisitedPage();

					}
					else {
						if (attrs.assesment == "true") {
							$rootScope.asmntScoreArray[$rootScope.quizCounter - 1] = 0;
							$rootScope.isAnswered = true;
						}
						scope.failed = true;
						if (curretAttempt < maxAttempt) {
							scope.buttonText = $rootScope.CourseContent.tryAgainText;
							feedbackSetText(pertialFeedback);
						} else {
							$(".btn-submit").attr("disabled", true);
							//$(".btn-submit").hide();
							feedbackSetText(incorrectFeedback);
							scope.showAnser = true;
							$rootScope.markVisitedPage();
							$(".btn-show-ans").attr("disabled", false);
						}
					}
				} else {
					$("#cart_1 ,#cart_2, #cart_3, #cart_4").find('.cart').css('display', 'none');
					curretAttempt++;
					scope.feedbackToggle = false;
					//$(".btn-reset").attr("disabled", true);
					//$(".btn-submit").hide();
					enableOption()
					for (var i = 1; i <= noOfDragable; i++) {
						$("#draggable_" + i).draggable('enable')
						$("#draggable_" + i).appendTo("#dragarea_" + i);
						$("#draggable_" + i).css("margin", "5px");
						$("#draggable_" + i).animate({ top: 0, left: 0 }, { duration: 600, easing: 'easeOutBack' });
						$("#target_" + i).removeClass('redBorder');
						$("#target_" + i).removeClass('greenBorder');
						//$("#target_"+i).css("border","#666666 dashed thin");
						$("#target_" + i).droppable("enable");
						$("#target_" + i).data("id", 0);
						$("#draggable_" + i).data("id", 0);
						$("#draggable_" + i).css({ 'width': '500px', 'margin': '0px' })
						$("#draggable_" + i).find('p').removeClass('afterDrag onDrag');
					}
					if (submitEnable == 0)
						$(".btn-submit").attr("disabled", true);
					scope.buttonText = $rootScope.CourseContent.submitText;

					scope.showOption(1);


				}
			}

			function disableOption() {
				for (var i = 1; i <= noOfDragable; i++) {
					$("#draggable_" + i).draggable("disable").css("cursor", "default");
				}
			}

			function feedbackSetText(value) {
				scope.feedback = value;
				//console.log("----------------")
				//console.log(scope.feedback)
			}

			function enableOption() {
				for (var i = 1; i <= noOfDragable; i++) {
					$("#draggable_" + i).draggable("enable").css("cursor", "move");;
				}
			}

			function showCorrectAns() {
				for (var i = 1; i <= noOfDragable; i++) {
					$("#draggable_" + i).addClass('greenBorder');
				}
			}


			$timeout(function () {
				scope.start();
			}, 1000);
			//---- For Ipad
			(function ($) {
				// Detect touch support
				$.support.touch = 'ontouchend' in document;
				// Ignore browsers without touch support
				if (!$.support.touch) {
					return;
				}
				var mouseProto = $.ui.mouse.prototype,
					_mouseInit = mouseProto._mouseInit,
					touchHandled;

				function simulateMouseEvent(event, simulatedType) { //use this function to simulate mouse event
					// Ignore multi-touch events
					if (event.originalEvent.touches.length > 1) {
						return;
					}
					event.preventDefault(); //use this to prevent scrolling during ui use

					var touch = event.originalEvent.changedTouches[0],
						simulatedEvent = document.createEvent('MouseEvents');
					// Initialize the simulated mouse event using the touch event's coordinates
					simulatedEvent.initMouseEvent(
						simulatedType,    // type
						true,             // bubbles                    
						true,             // cancelable                 
						window,           // view                       
						1,                // detail                     
						touch.screenX,    // screenX                    
						touch.screenY,    // screenY                    
						touch.clientX,    // clientX                    
						touch.clientY,    // clientY                    
						false,            // ctrlKey                    
						false,            // altKey                     
						false,            // shiftKey                   
						false,            // metaKey                    
						0,                // button                     
						null              // relatedTarget              
					);

					// Dispatch the simulated event to the target element
					event.target.dispatchEvent(simulatedEvent);
				}
				mouseProto._touchStart = function (event) {
					var self = this;
					// Ignore the event if another widget is already being handled
					if (touchHandled || !self._mouseCapture(event.originalEvent.changedTouches[0])) {
						return;
					}
					// Set the flag to prevent other widgets from inheriting the touch event
					touchHandled = true;
					// Track movement to determine if interaction was a click
					self._touchMoved = false;
					// Simulate the mouseover event
					simulateMouseEvent(event, 'mouseover');
					// Simulate the mousemove event
					simulateMouseEvent(event, 'mousemove');
					// Simulate the mousedown event
					simulateMouseEvent(event, 'mousedown');
				};

				mouseProto._touchMove = function (event) {
					// Ignore event if not handled
					if (!touchHandled) {
						return;
					}
					// Interaction was not a click
					this._touchMoved = true;
					// Simulate the mousemove event
					simulateMouseEvent(event, 'mousemove');
				};
				mouseProto._touchEnd = function (event) {
					// Ignore event if not handled
					if (!touchHandled) {
						return;
					}
					// Simulate the mouseup event
					simulateMouseEvent(event, 'mouseup');
					// Simulate the mouseout event
					simulateMouseEvent(event, 'mouseout');
					// If the touch interaction did not move, it should trigger a click
					if (!this._touchMoved) {
						// Simulate the click event
						simulateMouseEvent(event, 'click');
					}
					// Unset the flag to allow other widgets to inherit the touch event
					touchHandled = false;
				};
				mouseProto._mouseInit = function () {
					var self = this;
					// Delegate the touch handlers to the widget's element
					self.element
						.on('touchstart', $.proxy(self, '_touchStart'))
						.on('touchmove', $.proxy(self, '_touchMove'))
						.on('touchend', $.proxy(self, '_touchEnd'));
					// Call the original $.ui.mouse init method
					_mouseInit.call(self);
				};
			})(jQuery);


		}
	}
});

//Directive to implement Interactivity Like
FrameworkApp.directive('LikeInteractivity', function () {
	return {
		restrict: 'C',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope, $timeout) {
			$scope.popupopen = false;
			$scope.currentButton = 1;
			$scope.feedback = [];
			$scope.statBtn = function (inx) {
				if (inx < $scope.currentButton)
					return "enable-overlay";
			};
			$scope.visited = false;
			$scope.submitAns = function (btn, id) {
				$rootScope.checkInternet($rootScope.selectedLang);
				isButtonClick = true;
				$scope.totalButton = ($rootScope.CourseContent.screen[1].LikeInteractivity.length)
				$('#feed_' + $scope.currentButton).show();
				if ($rootScope.CourseContent.screen[1].LikeInteractivity[$scope.currentButton - 1].CorrectAnswer == btn) {
					if (btn == "like") {
						$('.like_status_' + $scope.currentButton).append("<span class='glyphicon glyphicon-ok'></span>");
						/* $('.unlike_status_'+$scope.currentButton).append("<span class='glyphicon glyphicon-remove'></span>"); */
					} else {
						/* $('.like_status_'+$scope.currentButton).append("<span class='glyphicon glyphicon-remove'></span>"); */
						$('.unlike_status_' + $scope.currentButton).append("<span class='glyphicon glyphicon-ok'></span>");
					}

					$scope.feedback[$scope.currentButton - 1] = $rootScope.CourseContent.screen[1].LikeInteractivity[$scope.currentButton - 1].CorrectFeedback;
				}
				else {
					if ($rootScope.CourseContent.screen[1].LikeInteractivity[$scope.currentButton - 1].CorrectAnswer == "like") {
						/* $('.like_status_'+$scope.currentButton).append("<span class='glyphicon glyphicon-ok'></span>");  */
						$('.unlike_status_' + $scope.currentButton).append("<span class='glyphicon glyphicon-remove'></span>");
					} else {
						$('.like_status_' + $scope.currentButton).append("<span class='glyphicon glyphicon-remove'></span>");
						/* $('.unlike_status_'+$scope.currentButton).append("<span class='glyphicon glyphicon-ok'></span>"); */
					}
					$scope.feedback[$scope.currentButton - 1] = $rootScope.CourseContent.screen[1].LikeInteractivity[$scope.currentButton - 1].inccorrectfeedback;
				}

				if ($scope.totalButton == $scope.currentButton) {
					/* $timeout(function(){
						$scope.popupopen = true;	 */
					$rootScope.markVisitedPage();
					//},500);
					/* $timeout(function(){
						$scope.popupopen1 = true;		 */
					$rootScope.markVisitedPage();
					//},3000);
					$scope.showBtns = true;
				}
				//$scope.feedback[$scope.currentButton-1]=$rootScope.CourseContent.screen[1].LikeInteractivity[$scope.currentButton-1].feedback;
				//alert($scope.totalButton+"=="+$scope.currentButton);
				$("#" + id + $scope.currentButton).css("opacity", "1");
				$("#overlay_" + $scope.currentButton).css("opacity", "1");
				$scope.currentButton++;

			}
		}
	}
});



//Directive to implement Hot Word
FrameworkApp.directive('hotword', function ($rootScope) {
	return {
		restrict: 'CA',
		controller: function ($scope, $rootScope) {
			$scope.popupToggle = false;
			$scope.displayPDF = false;
			var visitedHWArray = [];
			$scope.openPopup = function (key) {
				$rootScope.checkInternet($rootScope.selectedLang);
				$scope.hideQuestion = true;
				$scope.popupHead = $rootScope.CourseContent[key].header;
				$scope.popupText = $rootScope.CourseContent[key].content;
				$scope.clsName = key;
				$scope.popupToggle = true;
				$scope.displayPDF = false;
				if (visitedHWArray.indexOf(key) == -1) {
					visitedHWArray.push(key);
					if (visitedHWArray.length == $rootScope.CourseContent.numberofhotwords) {
						$rootScope.markVisitedPage();
					}
				}
			};

			$scope.slideUpPop = function (id) {
				$('.' + id).removeClass('slideInDown').addClass('slideOutUp')
			}

			$scope.closepopup = function () {
				$rootScope.checkInternet($rootScope.selectedLang);
				$scope.displayPDF = true;
				$scope.popupToggle = false;
				$scope.popupHead = '';
				$scope.popupText = '';
			}
		}
	}
});



FrameworkApp.directive('hotwordafterclick', function ($rootScope) {
	return {
		restrict: 'CA',
		controller: function ($scope, $rootScope) {
			$scope.popupToggle = false;
			$scope.displayPDF = false;
			var visitedHWArray = [];
			$scope.openPopup = function (key) {
				$rootScope.checkInternet($rootScope.selectedLang);
				$scope.hideQuestion = true;
				$scope.popupHead = $rootScope.CourseContent[key].header;
				$scope.popupText = $rootScope.CourseContent[key].content;
				$scope.clsName = key;
				$scope.popupToggle = true;
				$scope.displayPDF = false;
				if (visitedHWArray.indexOf(key) == -1) {
					visitedHWArray.push(key);
					if (visitedHWArray.length == $rootScope.CourseContent.numberofhotwords) {

					}
				}
			};

			$scope.slideUpPop = function (id) {
				$('.' + id).removeClass('slideInDown').addClass('slideOutUp')
			}

			$scope.closepopup = function () {
				$rootScope.checkInternet($rootScope.selectedLang);
				$rootScope.markVisitedPage();
				$scope.displayPDF = true;
				$scope.popupToggle = false;
				$scope.popupHead = '';
				$scope.popupText = '';
			}
		}
	}
});

FrameworkApp.directive('gotoPage', function () {
	$rootScope.assesmentScore = 0;
	return {
		restrict: 'C',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope) {
			$scope.gotoPageNum = function (e) {
				if (e > 1) {
					$rootScope.loadScreen($rootScope.currentModule, $rootScope.currentTopic, (e - 1));
				}
				else {
					$rootScope.loadScreen($rootScope.currentModule, $rootScope.currentTopic, 0);
				}
			}
			$rootScope.gotoPage = true;
			$rootScope.isNextButtonDisabled = true;

		}
	}
});


FrameworkApp.directive('myPostRepeatDirective', function () {
	return function (scope, element, attrs) {
		if (scope.$last) {
			$('.-accordion').asAccordion({
				namespace: '-accordion',
				// accordion theme. WIP
			});
		}
	}
});

FrameworkApp.directive('verticalAccordian', function () {
	var counter = 0;
	return {
		restrict: 'C',
		controller: function ($rootScope) {
			if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == "1") {
				setTimeout(function () { $(".dummyClas").parents("v-pane-header").addClass("visited") }, 1000);
			}

		},
		link: function ($rootScope, scope, element, attrs) {
			$('.vAccordion--default').click(function () {
				counter = $(".visited").length;
				var len = $('v-pane-header').length;
				if (counter === len) {
					$rootScope.markVisitedPage();
				}
			});
			$('v-pane-header').click(function () {


			});
		}

	}
});

FrameworkApp.directive('btnClickType3', function () {
	var tempVisited = '';
	return {
		restrict: 'CA',
		link: function ($scope, $rootScope, elem, attrs) {
			tempVisited = '';
		},
		controller: function ($scope, $rootScope, $timeout, $interval) {
			if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == "1") {
				$(".btnClickType3").addClass("visited");
				if ($rootScope.isPassed[4] == 0 && $rootScope.currentTopic == 5 && ($rootScope.currentPage == 3 || $rootScope.currentPage == 4)) {
					$rootScope.isNextButtonDisabled = true;
					$(".btnClickType3").removeClass("visited");
				}
			}
			var tempVisit = '';
			var counter = 0;
			var timer;
			$scope.clicked = false;
			$scope.openpopup = false;
			$scope.active = 1;
			$scope.disableNextBtn = 1;
			$scope.count = 1;
			$scope.tCount = 0;
			$scope.showBluePatch = false;
			$scope.showGiveUp = false;
			$scope.clickCounter = [];
			$(".accordian-panel").hide();
			$scope.loadcontent = function (event, pItem, _type) {
				$rootScope.checkInternet($rootScope.selectedLang);
				$scope.openpopup = true;
				$(".accordian-panel").show();
				$scope.count = parseInt(pItem.id);
				var flag = $('.clickables');
				if (!$(flag[0]).hasClass("markCompleted"))
					$(flag[0]).addClass("markCompleted");
				$(flag[pItem.id - 1]).removeClass("markCompleted");
				$(tempVisit).addClass("markCompleted");
				tempVisit = $(flag[pItem.id - 1]);
				$(".btnClickType3").removeClass("selected");
				$($(".btnClickType3")[$scope.count - 1]).addClass("selected");
				$scope.Buttontext = pItem.text;
				$scope.clicked = true;
				$scope.checkCompletion($scope.count - 1);
				if ($scope.clickCounter.length > 0) {
					$(tempVisited).addClass("visited");
				}
				tempVisited = $(event.currentTarget);
				if (_type === "cType") {
					if ($scope.clickCounter.indexOf(0) == -1) {
						$scope.clickCounter.push(0);
					}
				}
			}
			$scope.onClickSend = function () {
				$scope.sendDisable = true;
				$scope.firstPopup = true;
				$scope.enableNext = true;
				$scope.disableNextBtn = 0;
				$scope.$apply()
			}
			$scope.close = function () {
				$rootScope.checkInternet($rootScope.selectedLang);
				$(tempVisited).addClass("visited");
				$scope.openpopup = false;
			};
			$scope.onNextBack = function (state) {
				$rootScope.checkInternet($rootScope.selectedLang);
				if (state == 'back') {
					if (timer)
						$interval.cancel(timer)
					if ($scope.count < 2) {
						return;
						$scope.Buttontext = $rootScope.CourseContent.btn_click_learn[$scope.count - 1].text;
					} else {
						$scope.count--;
						$scope.Buttontext = $rootScope.CourseContent.btn_click_learn[$scope.count - 1].text;
					}
				}
				else if (state == 'next') {
					if ($scope.count > $rootScope.CourseContent.btn_click_learn.length - 1) return;//$scope.count = 0; //return;;
					$scope.count++;
					$scope.Buttontext = $rootScope.CourseContent.btn_click_learn[$scope.count - 1].text;
					$scope.showBluePatch = true;
					if ($scope.count > $rootScope.CourseContent.btn_click_learn.length - 1) {
						$scope.timeShow = 0;
						timer = $interval(function () {
							$scope.timeShow++;
							if ($scope.timeShow >= $rootScope.CourseContent.totalTIme) {
								$scope.showGiveUp = true;
								$interval.cancel(timer)
							}
						}, 1000);

						$scope.$on('$destroy', function () {
							$interval.cancel(timer)
						});
						if (!$rootScope.CourseContent.btn_click_learn[$scope.count - 1].sbBtn)
							$rootScope.markVisitedPage();
					}
				}

				var flag = $('.clickables');
				if (!$(flag[0]).hasClass("markCompleted"))
					$(flag[0]).addClass("markCompleted");
				$(flag[$scope.count - 1]).removeClass("markCompleted");
				$(tempVisit).addClass("markCompleted");
				tempVisit = $(flag[$scope.count - 1]);

				$scope.active = $scope.count;
				if (!$rootScope.CourseContent.btn_click_learn[$scope.count - 1].sbBtn)
					$scope.checkCompletion($scope.count - 1);
				if ($scope.clickCounter.indexOf(0) == -1) {
					$scope.clickCounter.push(0);
				}
			}

			$scope.getDisabledclass = function (id) {
				if ($scope.disableNextBtn == 1 || id == 2) {
					return 'disabled';

				}

			}
			$scope.checkCompletion = function (_val) {
				if ($scope.clickCounter.indexOf(_val) == -1)
					$scope.clickCounter.push(_val)
				if ($scope.clickCounter.length == $rootScope.CourseContent.btn_click_learn.length)
					$scope.markVisitedPage();
			};
			$scope.download = function () {
			};
		}
	}
});
FrameworkApp.directive('result', function () {
	return {
		restrict: 'AC',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope) {

			$rootScope.assesmentStarted = false;
			if ($rootScope.assesmentAttempted < $rootScope.CourseConfig.MaxAssesmentAttempt)
				$rootScope.showTryAgain = true;
			else
				$rootScope.showTryAgain = false;
			$rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] = "1";
			$rootScope.setCourseAsComplete();
		}
	}
});

FrameworkApp.directive('resultpage', function () {
	return {
		restrict: 'AC',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope) {
			var currentTime = new Date();
			var month = currentTime.getMonth() + 1;
			var day = currentTime.getDate();
			var year = currentTime.getFullYear();
			$scope.dateString = month + "/" + day + "/" + year;
			$(".menu-contain").css("pointer-events", "all");
			$('.menu-contain').css('opacity', '1');
			$rootScope.assesmentStarted = false;
			$rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] = "1";
			if ($rootScope.assesmentAttempted < $rootScope.CourseConfig.MaxAssesmentAttempt)
				$rootScope.showTryAgain = true;
			else
				$rootScope.showTryAgain = false;

			$rootScope.assesmentPercentageScore = Math.round(($rootScope.assesmentScore / $rootScope.CourseConfig.AvailableAssessmentQuestion) * 100);
			//console.log($rootScope.assesmentPercentageScore);			

			if ($rootScope.CourseConfig.AppType.toLowerCase() == 'scorm1.2') {
				if ($rootScope.assesmentPercentageScore >= $rootScope.CourseConfig.MasteryScore) {
					parent.SCORM_SetScore($rootScope.assesmentPercentageScore);
					parent.SCORM_SetPassed();
				}
				else {
					parent.SCORM_SetScore($rootScope.assesmentPercentageScore);
					parent.SCORM_SetFailed();
				}
				parent.SCORM_CallLMSCommit();
			}
			$scope.retakeAssesment = function () {
				$rootScope.assesmentScore = 0;
				$rootScope.assesmentQuestionIndex = [];
				$scope.questionsArray[0] = Math.ceil(Math.random() * 5);
				$rootScope.quizCounter = $scope.questionsArray[0];
				//console.log($rootScope.quizCounter)
				$rootScope.assesmentStarted = true;
				$rootScope.isNextButtonDisabled = false;
				$rootScope.isPrevButtonDisabled = true;
				$rootScope.isLastQuestion = false;
				$rootScope.asmntScoreArray = [2, 2, 2, 2, 2];
				//$rootScope.loadVisualMenu();
				$rootScope.showResumeBtn = false;
				$rootScope.assesmentQuestionIndex[0] = 1;
				$rootScope.loadScreen($rootScope.currentModule, $rootScope.currentTopic, 0)
			}

			$scope.proceedToCertficate = function () {
				$scope.gotoNextPage();
				$rootScope.isLastQuestion = false;
			};


		}
	}
});

//Directive to implement Assessment Result
FrameworkApp.directive('assesmentResult', function () {
	return {
		restrict: 'C',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope) {

			// $(".home-btn").addClass("btnDisabled");
			$(".audio-btn").addClass("disablePlay");
			$(".transcript-btn").addClass("disablePlay");
			$(".replayBtn").addClass("disablePlay");
			$rootScope.disableMenu = false;
			if ($rootScope.currentTopic == $rootScope.CourseConfig.PreAssessmentSection - 1)
				$rootScope.isNextButtonDisabled = false;
			$rootScope.assesmentStarted = false;
			$rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] = "1";
			if ($rootScope.assesmentAttempted < $rootScope.CourseConfig.MaxAssesmentAttempt)
				$rootScope.showTryAgain = true;
			else
				$rootScope.showTryAgain = false;
			if ($rootScope.currentTopic == 0 && $rootScope.CourseConfig.HasPreAssessment) {
				$rootScope.assesmentPercentageScore = Math.round(($rootScope.assesmentScore / $rootScope.CourseConfig.AvailablePreQuestions) * 100);
				$rootScope.assesmentPercentageScore = Math.round($rootScope.assesmentPercentageScore);
				$rootScope.isPrevButtonDisabled = true;
				$rootScope.isNextButtonDisabled = false;
			} else {
				$rootScope.assesmentPercentageScore = Math.round(($rootScope.assesmentScore / $rootScope.CourseConfig.AvailableAssessmentQuestion) * 100);
				$rootScope.assesmentPercentageScore = Math.round($rootScope.assesmentPercentageScore);
			}
			if ($rootScope.assesmentPercentageScore >= 60 && $rootScope.currentTopic == 0) {
				$rootScope.isPassed[0] = 1;
			}
			else if ($rootScope.currentTopic == 0 && $rootScope.isPassed[0] == 2) {
				$rootScope.isPassed[0] = 0;
			}
			//console.log($rootScope.resumeLastPage)
			if ($rootScope.assesmentPercentageScore >= $rootScope.CourseConfig.MasteryScore && $rootScope.currentTopic == $rootScope.CourseMenu.module.topics.length - 1 && !$rootScope.resumeLastPage) {
				//ispassed[1] will be 1 if passed post assesment
				$rootScope.isPassed[1] = 1;
				//ispassed[2] will be number of correct answers in the last attempt of final assessment
				$rootScope.isPassed[2] = $rootScope.assesmentScore;
			}
			else if ($rootScope.currentTopic == $rootScope.CourseMenu.module.topics.length - 1 && !$rootScope.resumeLastPage) {
				//ispassed[1] will be 0 if failed post assesment
				$rootScope.isPassed[1] = 0;
				//ispassed[2] will be number of correct answers in the last attempt of final assessment
				$rootScope.isPassed[2] = $rootScope.assesmentScore;
				//console.log($rootScope.resumeLastPage+"$rootScope.resumeLastPage$rootScope.resumeLastPage$rootScope.resumeLastPage$rootScope.resumeLastPage$rootScope.resumeLastPage")
			}
			if ($rootScope.CourseConfig.AppType.toLowerCase() == 'scorm1.2') {
				var sScore = Math.round((parseInt($rootScope.isPassed[2]) / $rootScope.CourseConfig.AvailableAssessmentQuestion) * 100);
				//alert(sScore+"================="+$rootScope.assesmentPercentageScore);
				if ($rootScope.currentTopic != $rootScope.CourseConfig.PreAssessmentSection - 1) {
					$rootScope.assesmentPercentageScore = sScore;
					$rootScope.assesmentScore = $rootScope.isPassed[2];
				}
				$rootScope.assesmentScore = $rootScope.isPassed[2];

				if ($rootScope.assesmentPercentageScore >= $rootScope.CourseConfig.MasteryScore && $rootScope.currentTopic != $rootScope.CourseConfig.PreAssessmentSection - 1) {

					/* $rootScope.courseStatus = scormAdaptor_getstatus(); */
					$rootScope.courseStatus = parent.SCORM_GetStatus();

					if ($rootScope.courseStatus == "incomplete" || $rootScope.courseStatus == "failed") {
						//scormAdaptor_setscore($rootScope.assesmentPercentageScore);				
					}
					//alert("--------"+$rootScope.isPassed[3])
					if ($rootScope.isPassed[3] == "d") {

						$rootScope.isPassed[3] = $rootScope.getDate();

					}

					$rootScope.setSuspend();


					parent.SCORM_SetScore($rootScope.assesmentPercentageScore)
					$rootScope.getScore = parent.SCORM_GetScore();
					parent.SCORM_SetCompleted();
					parent.SCORM_CommitData();
				} else if ($rootScope.assesmentPercentageScore >= 60 && $rootScope.currentTopic == $rootScope.CourseConfig.PreAssessmentSection - 1) {
					if ($rootScope.isPassed[3] == "d") {
						$rootScope.isPassed[3] = $rootScope.getDate();

					}
					$rootScope.setSuspend();
					//scormAdaptor_setscore($rootScope.assesmentPercentageScore);
					parent.SCORM_SetScore($rootScope.assesmentPercentageScore)
					$rootScope.getScore = parent.SCORM_GetScore();
					//alert($rootScope.getScore+"========sss======="+$rootScope.assesmentPercentageScore);				
					parent.SCORM_SetCompleted();
					parent.SCORM_CommitData();
				}
				else if ($rootScope.currentTopic != $rootScope.CourseConfig.PreAssessmentSection - 1) {
					//alert("opop")
					$rootScope.getScore = parent.SCORM_GetScore();
					$rootScope.courseStatus = parent.SCORM_GetStatus();
					if ($rootScope.courseStatus != "passed") {
						parent.SCORM_SetScore($rootScope.assesmentPercentageScore);
						parent.SCORM_SetFailed();
						parent.SCORM_CommitData();
					}

				}
			} else {
				$rootScope.getScore = Math.round(($rootScope.assesmentScore / $rootScope.CourseConfig.AvailableAssessmentQuestion) * 100);
			}
			$scope.calculateScore = function () {
				var cScore = Math.round((parseInt($rootScope.isPassed[2]) / $rootScope.CourseConfig.AvailableAssessmentQuestion) * 100)
				//alert("cScore==========="+cScore)
				if ($rootScope.CourseConfig.AppType.toLowerCase() == 'scorm1.2') {
					if (cScore >= 60) {
						$rootScope.assesmentScore = $rootScope.isPassed[2];
						parent.SCORM_SetScore(cScore)
						parent.SCORM_CommitData();
					}
				}
				//console.log(cScore)
				return cScore;

			}
			$scope.retakeAssesment = function () {
				$rootScope.checkInternet($rootScope.selectedLang);
				if (navigator.onLine) {
					$rootScope.assesmentScore = 0;
					$rootScope.assesmentAttempted++;
					$rootScope.assesmentQuestionIndex = [];
					$rootScope.assesmentStarted = true;
					$rootScope.isNextButtonDisabled = true;
					$rootScope.isPrevButtonDisabled = true;
					$rootScope.assesmentScore = 0;
					$rootScope.createaAssesment();
					if ($rootScope.audioFile) {
						$(".audio-btn").removeClass("disablePlay");
						$(".transcript-btn").removeClass("disablePlay");
						$(".replayBtn").addClass("disablePlay");
					}
					$rootScope.loadScreen($rootScope.currentModule, $rootScope.currentTopic, 1)
				}
			}
			setTimeout(function () {
				$('#progressRound').pieChart({
					barColor: '#ffd500',
					trackColor: '#d8d8d8',
					lineCap: 'butt',
					lineWidth: 18,
					percentage: $rootScope.assesmentPercentageScore,
					onStep: function (from, to, percent) {
						$(this.element).find('.pie-value').text(Math.round(percent) + '%');
					}
				});
			}, 1000);
			$rootScope.isNextButtonDisabled = true;
		}
	}
});

FrameworkApp.directive('samc', function ($rootScope, $timeout) {
	return {
		restrict: 'AE',
		scope: {},
		template: '<ng-include src="getTemplateUrl()"/>',
		link: function (scope, elem, attrs) {
			var template = attrs.templateUrl;
			scope.getTemplateUrl = function () {
				return '../html5/Views/kc/' + template + '.html';
			};
			if (attrs.assesment == "true") {
				$(".menu-contain").css("pointer-events", "none");
				$('.menu-contain').css('opacity', '0.5');
				$rootScope.isPrevButtonDisabled = true;
				$rootScope.isNextButtonDisabled = true;
				$rootScope.disableMenu = true;
				$(".home-btn").addClass("btnDisabled");
				$(".replayBtn").addClass("disablePlay");
				$(".next").removeClass("animNxt");
			}
			scope.selection = 1;
			scope.isBranching = false;
			scope.disableButton = true;
			scope.start = function () {
				scope.id = 0;
				scope.attempt = 0;
				scope.disableInput = false;
				scope.quizOver = false;
				scope.inProgress = true;
				scope.getQuestion();
				scope.feedbackToggle = false;
				scope.buttonText = $rootScope.CourseContent.submitText;
				scope.maxAttempt = $rootScope.CourseContent.maximumAttempt;
				scope.feedback = "";
				scope.feedback_bg = $rootScope.CourseContent.feedback_bg_path;

			};

			scope.manageQuestion = function () {

			};

			scope.reset = function () {
				scope.inProgress = false;
				scope.score = 0;
			};
			var timer = true;
			$timeout(function () {
				timer = false;
			}, 1500)
			scope.onOptionSelected = function (pIndex) {
				if (attrs.assesment == "true") {
					if (timer)
						return;
				}
				if ($('input[name=answer]:checked').length > 0)
					scope.disableButton = false;
				else
					scope.disableButton = true;
				if ($(".kc-option").children().hasClass("option-selected")) {
					$(".kc-option").children().removeClass("option-selected");
				}
				$("#options label").eq(pIndex).addClass("option-selected");

			};

			scope.getQuestion = function () {
				scope.options = $rootScope.CourseContent.question;
			};

			scope.checkAnswer = function () {
				$rootScope.blinkQuizWrapper = true;
				if (scope.buttonText == $rootScope.CourseContent.submitText) {
					if (attrs.feedback == "true")
						scope.feedbackToggle = true;
					if (!$('input[name=answer]:checked').length) return;
					if ($('input[name=answer]:checked').attr("correct") == "true") {
						if (attrs.assesment == "true") {
							$rootScope.assesmentScore++;
							$rootScope.asmntScoreArray[$rootScope.quizCounter - 1] = 1;
							$rootScope.isAnswered = true;
						}
						scope.feedback = $rootScope.CourseContent.correct_feedback;
						scope.disableButton = true;
						scope.disableInput = true;
						if (!$rootScope.CourseContent.branchingScreen) {
							$timeout(function () {
								$rootScope.markVisitedPage();
							}, 200)
						}
						else {
							scope.isBranching = true;
						}
						$('.kc-option-label').css('cursor', 'default');
					} else {
						scope.feedback = $rootScope.CourseContent.incorrect_feedback;
						if (attrs.assesment == "true") {
							$rootScope.asmntScoreArray[$rootScope.quizCounter - 1] = 0;
							$rootScope.isAnswered = true;
						}
						if (scope.attempt < scope.maxAttempt - 1) {
							scope.buttonText = $rootScope.CourseContent.resetText;
							scope.feedback = $rootScope.CourseContent.tryagain_feedback;
							$(".kc-option-label").css("cursor", "default");
							scope.disableInput = true;

						}
					}
					if (attrs.tickmark == "true")
						scope.checkUserAnswer();
					scope.attempt++;
				}
				else {
					scope.feedbackToggle = false;
					$('input[name=answer]:checked').parent().parent().removeClass("correct");
					$('input[name=answer]:checked').parent().parent().removeClass("in-correct");
					$('input[name=answer]:checked').attr('checked', false);
					scope.buttonText = $rootScope.CourseContent.submitText;
					scope.disableInput = false;
					scope.disableButton = true;
					if ($(".kc-option").children().hasClass("option-selected")) {
						$(".kc-option").children().removeClass("option-selected");
					}
					$(".kc-option-label").css("cursor", "pointer");

				}
				scope.answerMode = false;
				if (scope.attempt >= scope.maxAttempt) {
					scope.disableInput = true;
					scope.disableButton = true;
					if (!$rootScope.CourseContent.branchingScreen) {
						$timeout(function () {
							$rootScope.markVisitedPage();
						}, 200)
					}
					else {
						scope.isBranching = true;
					}
					if (attrs.tickmark == "true")
						scope.showAnswer();
				}
				console.log($rootScope.assesmentScore)
			};

			scope.checkUserAnswer = function () {
				if ($('input[name=answer]:checked').attr("correct") == "true") {
					$('input[name=answer]:checked').parent().parent().addClass("correct")
				}
				else {
					$('input[name=answer]:checked').parent().parent().addClass("in-correct")
				}

				//console.log("attrs.assesment "+attrs.assesment)
				if (attrs.assesment == "true") {
					scope.checkQuizCompletion();
				}

			};

			scope.checkQuizCompletion = function () {
				if ($rootScope.currentPageNumber == $rootScope.totalPages - 1) {
					$rootScope.assesmentAttempted++;
					$timeout(function () {
						$rootScope.isLastQuestion = true;
						$rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage + 1] = "1"
					}, 1000);
				}
			};

			scope.showAnswer = function () {
				var checkAnswer = document.getElementsByName('answer');
				for (var i = 0; i < checkAnswer.length; i++) {
					if ($(checkAnswer[i]).attr("correct") == "true") {
						$(checkAnswer[i]).parent().parent().addClass("correct");
						$('.kc-option-label').css('cursor', 'default');
					}
				}
			}
			scope.nextQuestion = function () {
				scope.id++;
				scope.getQuestion();
			};
			scope.reset();
			scope.start();
		}
	}
});





FrameworkApp.directive('samcoption', function ($rootScope, $timeout) {
	return {
		restrict: 'AE',
		scope: {},
		template: '<ng-include src="getTemplateUrl()"/>',
		link: function (scope, elem, attrs) {
			var template = attrs.templateUrl;
			scope.getTemplateUrl = function () {
				return '../html5/Views/kc/' + template + '.html';
			};
			if (attrs.assesment == "true") {
				$(".menu-contain").css("pointer-events", "none");
				$('.menu-contain').css('opacity', '0.5');
				$rootScope.isPrevButtonDisabled = true;
				$rootScope.isNextButtonDisabled = true;
				$rootScope.disableMenu = true;
				$(".home-btn").addClass("btnDisabled");
				$(".replayBtn").addClass("disablePlay");
				$(".next").removeClass("animNxt");
			}
			scope.selection = 1;
			scope.isBranching = false;
			scope.disableButton = true;
			scope.pIndex = 0
			scope.start = function () {
				scope.id = 0;

				scope.attempt = 0;
				scope.disableInput = false;
				scope.quizOver = false;
				scope.inProgress = true;
				scope.getQuestion();
				scope.feedbackToggle = false;
				scope.buttonText = $rootScope.CourseContent.submitText;
				scope.maxAttempt = $rootScope.CourseContent.maximumAttempt;
				scope.feedback = "";
				scope.feedback_bg = $rootScope.CourseContent.feedback_bg_path;

			};

			scope.manageQuestion = function () {

			};

			scope.reset = function () {
				scope.inProgress = false;
				scope.score = 0;
			};
			var timer = true;
			$timeout(function () {
				timer = false;
			}, 1500)
			scope.onOptionSelected = function (pIndex) {
				if (attrs.assesment == "true") {
					if (timer)
						return;
				}
				if ($('input[name=answer]:checked').length > 0)
					scope.disableButton = false;
				else
					scope.disableButton = true;
				if ($(".kc-option").children().hasClass("option-selected")) {
					$(".kc-option").children().removeClass("option-selected");
				}
				$("#options label").eq(pIndex).addClass("option-selected");
				scope.pIndex = pIndex
			};

			scope.getQuestion = function () {
				scope.options = $rootScope.CourseContent.question;
			};

			scope.checkAnswer = function () {
				$rootScope.blinkQuizWrapper = true;
				if (scope.buttonText == $rootScope.CourseContent.submitText) {
					if (attrs.feedback == "true")
						scope.feedbackToggle = true;
					if (!$('input[name=answer]:checked').length) return;
					if ($('input[name=answer]:checked').attr("correct") == "true") {
						if (attrs.assesment == "true") {
							$rootScope.assesmentScore++;
							$rootScope.asmntScoreArray[$rootScope.quizCounter - 1] = 1;
							$rootScope.isAnswered = true;
						}
						scope.feedback = $rootScope.CourseContent.correct_feedback[scope.pIndex];
						scope.disableButton = true;
						scope.disableInput = true;
						if (!$rootScope.CourseContent.branchingScreen) {
							$timeout(function () {
								$rootScope.markVisitedPage();
							}, 200)
						}
						else {
							scope.isBranching = true;
						}
						$('.kc-option-label').css('cursor', 'default');
					} else {
						scope.feedback = $rootScope.CourseContent.correct_feedback[scope.pIndex];
						if (attrs.assesment == "true") {
							$rootScope.asmntScoreArray[$rootScope.quizCounter - 1] = 0;
							$rootScope.isAnswered = true;
						}
						if (scope.attempt < scope.maxAttempt - 1) {
							scope.buttonText = $rootScope.CourseContent.resetText;
							scope.feedback = $rootScope.CourseContent.tryagain_feedback;
							$(".kc-option-label").css("cursor", "default");
							scope.disableInput = true;

						}
					}
					if (attrs.tickmark == "true")
						scope.checkUserAnswer();
					scope.attempt++;
				}
				else {
					scope.feedbackToggle = false;
					$('input[name=answer]:checked').parent().parent().removeClass("correct");
					$('input[name=answer]:checked').parent().parent().removeClass("in-correct");
					$('input[name=answer]:checked').attr('checked', false);
					scope.buttonText = $rootScope.CourseContent.submitText;
					scope.disableInput = false;
					scope.disableButton = true;
					if ($(".kc-option").children().hasClass("option-selected")) {
						$(".kc-option").children().removeClass("option-selected");
					}
					$(".kc-option-label").css("cursor", "pointer");

				}
				scope.answerMode = false;
				if (scope.attempt >= scope.maxAttempt) {
					scope.disableInput = true;
					scope.disableButton = true;
					if (!$rootScope.CourseContent.branchingScreen) {
						$timeout(function () {
							$rootScope.markVisitedPage();
						}, 200)
					}
					else {
						scope.isBranching = true;
					}
					if (attrs.tickmark == "true")
						scope.showAnswer();
				}
				console.log($rootScope.assesmentScore)
			};

			scope.checkUserAnswer = function () {
				if ($('input[name=answer]:checked').attr("correct") == "true") {
					$('input[name=answer]:checked').parent().parent().addClass("correct")
				}
				else {
					$('input[name=answer]:checked').parent().parent().addClass("in-correct")
				}

				//console.log("attrs.assesment "+attrs.assesment)
				if (attrs.assesment == "true") {
					scope.checkQuizCompletion();
				}

			};

			scope.checkQuizCompletion = function () {
				if ($rootScope.currentPageNumber == $rootScope.totalPages - 1) {
					$rootScope.assesmentAttempted++;
					$timeout(function () {
						$rootScope.isLastQuestion = true;
						$rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage + 1] = "1"
					}, 1000);
				}
			};

			scope.showAnswer = function () {
				var checkAnswer = document.getElementsByName('answer');
				for (var i = 0; i < checkAnswer.length; i++) {
					if ($(checkAnswer[i]).attr("correct") == "true") {
						$(checkAnswer[i]).parent().parent().addClass("correct");
						$('.kc-option-label').css('cursor', 'default');
					}
				}
			}
			scope.nextQuestion = function () {
				scope.id++;
				scope.getQuestion();
			};
			scope.reset();
			scope.start();
		}
	}
});

FrameworkApp.directive('mamc', function ($rootScope, $timeout) {
	return {
		restrict: 'E',
		scope: {},
		template: '<ng-include src="getTemplateUrl()"/>',
		link: function (scope, elem, attrs) {
			var template = attrs.templateUrl;
			scope.getTemplateUrl = function () {
				return '../html5/Views/kc/' + template + '.html';
			};
			if (attrs.assesment == "true") {
				$rootScope.isPrevButtonDisabled = true;
				$rootScope.isNextButtonDisabled = true;
				$rootScope.disableMenu = true;
				$(".home-btn").addClass("btnDisabled");
				$(".menu-contain").css("pointer-events", "none");
				$('.menu-contain').css('opacity', '0.5');
				$(".replayBtn").addClass("disablePlay");
				$(".next").removeClass("animNxt");
			}
			scope.selection = 1;
			scope.correctAnswer = [];
			scope.userAnswer = [];
			scope.options = "";
			scope.disableButton = true;
			scope.isBranching = false;
			scope.start = function () {
				scope.id = 0;
				scope.attempt = 0;
				scope.disableInput = false;
				scope.quizOver = false;
				scope.inProgress = true;
				scope.getQuestion();
				scope.feedbackToggle = false;
				scope.buttonText = $rootScope.CourseContent.submitText;
				scope.maxAttempt = $rootScope.CourseContent.maximumAttempt;
				scope.feedback = "";
				scope.feedback_bg = $rootScope.CourseContent.feedback_bg_path;
				scope.popuptext = $rootScope.CourseContent.popupcontent;
				scope.openpopup = false;

			};

			scope.reset = function () {
				scope.inProgress = false;
				scope.score = 0;
			};

			scope.onOptionSelected = function (pIndex) {
				if ($('input[name=answer]:checked').length > 0)
					scope.disableButton = false;
				else
					scope.disableButton = true;
				if ($("#options label").eq(pIndex).hasClass("option-selected")) {
					$("#options label").eq(pIndex).removeClass("option-selected");
				}
				else {
					$("#options label").eq(pIndex).addClass("option-selected");
				}
			};

			scope.getQuestion = function () {
				scope.options = $rootScope.CourseContent.question;
				for (i = 0; i < scope.options.length; i++) {
					if (scope.options[i].isCorrect == 'true')
						scope.correctAnswer.push(1);
					else
						scope.correctAnswer.push(0);
				}
			};

			scope.checkAnswer = function () {
				$rootScope.blinkQuizWrapper = true;
				if (scope.buttonText == $rootScope.CourseContent.submitText) {
					if (attrs.feedback == "true")
						scope.feedbackToggle = true;
					var AnswerList = document.getElementsByName('answer');
					for (var i = 0; i < AnswerList.length; i++) {
						if (AnswerList[i].checked) {
							scope.userAnswer.push(1);
						}
						else {
							scope.userAnswer.push(0);
						}
					}
					if (!$('input[name=answer]:checked').length) return;
					var tottalCorrectAns = 0;
					var tottaluserAns = 0;
					var tottaluserIncorrectAnswer = 0;
					for (var k = 0; k < scope.options.length; k++) {
						if (scope.correctAnswer[k] == 1) { tottalCorrectAns++; }
						if (scope.correctAnswer[k] == scope.userAnswer[k] && scope.userAnswer[k] == 1) {
							tottaluserAns++;
						}
						if (scope.userAnswer[k] == 1) {
							if (scope.userAnswer[k] != scope.correctAnswer[k]) {
								tottaluserIncorrectAnswer++;
							}
						}
					}
					if (JSON.stringify(scope.correctAnswer) == JSON.stringify(scope.userAnswer) && attrs.assesment == "true") {	//check both if answer is correct and assessment is true
						if (attrs.assesment == "true") {
							$rootScope.assesmentScore++;
							$rootScope.asmntScoreArray[$rootScope.quizCounter - 1] = 1;
							$rootScope.isAnswered = true;
						}
						scope.feedback = $rootScope.CourseContent.correct_feedback;
						scope.disableButton = true;
						scope.disableInput = true;
						if (!$rootScope.CourseContent.branchingScreen) {


							$timeout(function () {
								$rootScope.markVisitedPage();
							}, 200)

						}
						else {
							scope.isBranching = true;
						}
					}
					else {
						$rootScope.asmntScoreArray[$rootScope.quizCounter - 1] = 0;
						$rootScope.isAnswered = true;
						scope.feedback = $rootScope.CourseContent.incorrect_feedback;
						if (scope.attempt < scope.maxAttempt - 1) {
							scope.buttonText = $rootScope.CourseContent.resetText;
							scope.disableInput = true;
						}
					}
				}
				if (attrs.assesment != "true") {
					if (tottalCorrectAns == tottaluserAns && tottaluserIncorrectAnswer == 0) {
						scope.feedback = $rootScope.CourseContent.correct_feedback;
						if (scope.attempt < scope.maxAttempt - 1) {
							scope.buttonText = $rootScope.CourseContent.resetText;
							scope.disableInput = true;
						}
					}
					else if (tottaluserAns >= 1 && tottaluserIncorrectAnswer == 0) {
						scope.feedback = $rootScope.CourseContent.partial_correct_feedback;
						if (scope.attempt < scope.maxAttempt - 1) {
							scope.buttonText = $rootScope.CourseContent.resetText;
							scope.disableInput = true;
						}
					}
					else {
						scope.feedback = $rootScope.CourseContent.incorrect_feedback;
						if (scope.attempt < scope.maxAttempt - 1) {
							scope.buttonText = $rootScope.CourseContent.resetText;
							scope.disableInput = true;
						}
					}
				}
				if (attrs.tickmark == "true") {
					scope.checkUserAnswer();
					scope.attempt++;
				}
				else {
					scope.feedbackToggle = false;
					$('input[name=answer]:checked').attr('checked', false);
					scope.buttonText = $rootScope.CourseContent.submitText;
					scope.disableInput = false;
					scope.userAnswer = [];
					scope.disableButton = true;
					$('input[name=answer]').parent().parent().removeClass("correct");
					$('input[name=answer]').parent().parent().removeClass("in-correct");
					if ($(".kc-option").children().hasClass("option-selected")) {
						$(".kc-option").children().removeClass("option-selected");
					}
				}
				scope.answerMode = false;
				if (scope.attempt >= scope.maxAttempt) {
					scope.disableInput = true;
					scope.disableButton = true;
					if (!$rootScope.CourseContent.branchingScreen) {
						$timeout(function () {
							$rootScope.markVisitedPage();
						}, 200)
					}
					else {
						scope.isBranching = true;
					}
					if (attrs.tickmark == "true")
						scope.showAnswer();
				}
				scope.openpopup = true;
				if (attrs.assesment == "true")
					scope.checkQuizCompletion();
			};

			scope.checkQuizCompletion = function () {
				if ($rootScope.currentPageNumber == $rootScope.totalPages - 1) {
					$rootScope.assesmentAttempted++;
					$timeout(function () {
						$rootScope.isLastQuestion = true;
						$rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage + 1] = "1";
					}, 1000);
				}
			};

			scope.checkUserAnswer = function () {
				var checkAnswer = document.getElementsByName('answer');
				for (var i = 0; i < checkAnswer.length; i++) {
					if (checkAnswer[i].checked) {
						if (scope.correctAnswer[i] == 1) {
							$(checkAnswer[i]).parent().parent().addClass("correct")
						}
						else {
							$(checkAnswer[i]).parent().parent().addClass("in-correct")
						}
					}
				}
			};

			scope.showAnswer = function () {
				var checkAnswer = document.getElementsByName('answer');
				for (var i = 0; i < checkAnswer.length; i++) {
					if (scope.correctAnswer[i] == 1) {
						$(checkAnswer[i]).parent().parent().addClass("correct");
						$('.kc-option-label').css('cursor', 'default');
					}
				}
			};

			scope.nextQuestion = function () {
				scope.id++;
				scope.getQuestion();
			};
			scope.reset();
			scope.start();
		}
	}

});
FrameworkApp.directive('mamccyu2', function ($rootScope, $timeout) {
	return {
		restrict: 'E',
		scope: {},
		template: '<ng-include src="getTemplateUrl()"/>',
		link: function (scope, elem, attrs) {
			var template = attrs.templateUrl;
			scope.getTemplateUrl = function () {
				return '../html5/Views/kc/' + template + '.html';
			};
			scope.selection = 1;
			scope.correctAnswer = [];
			scope.userAnswer = [];
			scope.options = "";
			scope.disableButton = true;

			scope.isBranching = false;
			scope.start = function () {
				scope.id = 0;
				scope.attempt = 0;
				scope.disableInput = false;
				scope.quizOver = false;
				scope.inProgress = true;
				scope.getQuestion();
				scope.feedbackToggle = false;
				scope.buttonText = $rootScope.CourseContent.submitText;
				scope.maxAttempt = $rootScope.CourseContent.maximumAttempt;
				scope.disabletryAgain = false;
				scope.feedback = "";
				scope.disableButton = true;
				$(".btn-submit-q").css("opacity", "0.5");

			};

			scope.onOptionSelected = function (pIndex) {
				if ($('input[name=answer]:checked').length > 0) {
					scope.disableButton = false;
					scope.buttonText = $rootScope.CourseContent.submitText;
					$(".btn-submit-q").css("opacity", "1");
				}

				else {
					scope.disableButton = true;
					$(".btn-submit-q").css("opacity", "0.5");
				}

				if ($("#options label").eq(pIndex).hasClass("option-selected")) {
					$("#options label").eq(pIndex).removeClass("option-selected");
				}
				else {
					$("#options label").eq(pIndex).addClass("option-selected");
				}
			};

			scope.getQuestion = function () {
				scope.options = $rootScope.CourseContent.question;
				for (i = 0; i < scope.options.length; i++) {
					if (scope.options[i].isCorrect == 'true')
						scope.correctAnswer.push(1);
					else
						scope.correctAnswer.push(0);
				}
			};

			scope.checkAnswer = function () {
				if (scope.buttonText == $rootScope.CourseContent.submitText) {
					var AnswerList = document.getElementsByName('answer');
					for (var i = 0; i < AnswerList.length; i++) {
						if (AnswerList[i].checked) {
							scope.userAnswer.push(1);
						}
						else {
							scope.userAnswer.push(0);
						}
					}
					//console.log(scope.userAnswer);
					if (!$('input[name=answer]:checked').length) return;
					var tottalCorrectAns = 0;
					var tottaluserAns = 0;
					var tottaluserIncorrectAnswer = 0;
					for (var k = 0; k < scope.options.length; k++) {
						if (scope.correctAnswer[k] == 1) { tottalCorrectAns++; }
						if (scope.correctAnswer[k] == scope.userAnswer[k] && scope.userAnswer[k] == 1) {
							tottaluserAns++;
						}
						if (scope.userAnswer[k] == 1) {
							if (scope.userAnswer[k] != scope.correctAnswer[k]) {
								tottaluserIncorrectAnswer++;
							}
						}
					}
					scope.attempt++;
					if (tottalCorrectAns == tottaluserAns && tottaluserIncorrectAnswer == 0) {
						scope.feedback = $rootScope.CourseContent.correct_feedback;
						scope.disabletryAgain = true;
						scope.disableButton = true;
						$(".try-aggain").css("display", "none");
						$(".btn-submit-q").css("opacity", "0.5");
						scope.checkUserAnswer();
						$rootScope.markVisitedPage();
					}
					/* else if(tottaluserAns>=1 && tottaluserIncorrectAnswer==0){
						scope.feedback = $rootScope.CourseContent.partial_correct_feedback;
							
					} */
					else {
						scope.feedback = $rootScope.CourseContent["incorrect_feedback" + scope.attempt];
						//alert(scope.attempt)
						if (scope.attempt <= scope.maxAttempt - 1) {
							scope.buttonText = $rootScope.CourseContent.resetText;
							// $('option-selected').parent().parent().addClass("correct");
							// $('option-selected').parent().parent().addClass("in-correct");
							/* scope.disableInput = true;
							$(".btn-submit-q").css("opacity","0.5"); */
							scope.checkUserAnswer1Attempt();
						}
					}
					if (scope.attempt >= scope.maxAttempt) {
						//scope.feedback = $rootScope.CourseContent["incorrect_feedback"+scope.attempt];
						scope.disabletryAgain = true;
						$(".try-aggain").css("display", "none");
						scope.disableButton = true;
						$(".btn-submit-q").css("opacity", "0.5");
						$rootScope.markVisitedPage();
						scope.checkUserAnswer();
					}

					//console.log("scope.attempt ="+scope.attempt)
					//console.log("scope.maxAttempt ="+scope.maxAttempt)

					scope.disableInput = true;

					if (attrs.feedback == "true")
						scope.feedbackToggle = true;
					$(".kc-option-label").css("cursor", "default");
					if (attrs.tickmark == "true") {
						//scope.checkUserAnswer();
						//scope.attempt++;
					}
					else {
						scope.feedbackToggle = false;
						$('input[name=answer]:checked').attr('checked', false);
						scope.buttonText = $rootScope.CourseContent.submitText;
						scope.disableInput = false;
						scope.userAnswer = [];
						scope.disableButton = true;
						$('input[name=answer]').parent().parent().removeClass("correct");
						$('input[name=answer]').parent().parent().removeClass("in-correct");
						if ($(".kc-option").children().hasClass("option-selected")) {
							$(".kc-option").children().removeClass("option-selected");
						}
					}
				} else {
					scope.disableButton = true;
					scope.buttonText = $rootScope.CourseContent.submitText;
					scope.resetOptions();
					var checkAnswer = document.getElementsByName('answer');
					for (var i = 0; i < checkAnswer.length; i++) {

						if (scope.correctAnswer[i] == 1) {
							$(checkAnswer[i]).parent().removeClass("correct")
						}
						else if (checkAnswer[i].checked) {
							$(checkAnswer[i]).parent().removeClass("in-correct")
						}
						else {
							$(checkAnswer[i]).parent().removeClass("in-correct")
						}

					}
					$(".btn-submit-q").css("opacity", "0.5");

				}

			};


			scope.resetOptions = function () {
				scope.correctAnswer = [];
				scope.getQuestion();
				scope.userAnswer = [];
				$(".kc-option-label").removeClass("option-selected");
				$('input[name=answer]:checked').attr('checked', false);
				scope.disableInput = false;
				scope.feedbackToggle = false;
				scope.disableButton = true;
				$(".kc-option-label").css("cursor", "pointer");
			};


			scope.checkUserAnswer = function () {
				var checkAnswer = document.getElementsByName('answer');
				for (var i = 0; i < checkAnswer.length; i++) {
					if (scope.correctAnswer[i] == 1) {
						$(checkAnswer[i]).parent().addClass("correct")
					}
					else if (checkAnswer[i].checked) {
						$(checkAnswer[i]).parent().addClass("in-correct")
					}
				}
			};
			scope.checkUserAnswer1Attempt = function () {
				var checkAnswer = document.getElementsByName('answer');
				for (var i = 0; i < checkAnswer.length; i++) {
					if (checkAnswer[i].checked) {
						if (scope.correctAnswer[i] == 1) {
							$(checkAnswer[i]).parent().addClass("correct")
						}
						else if (checkAnswer[i].checked) {
							$(checkAnswer[i]).parent().addClass("in-correct")
						}
					}
				}
			};
			scope.start();
		}
	}

});

FrameworkApp.directive('sliderInteracitvity', function () {
	return {
		restrict: 'A',
		link: function () {
		},
		controller: function ($scope, $rootScope, $interval, $timeout, $rootScope) {
			$scope.disableSubmit = true;
			$scope.slide = 0;
			$scope.feedback = '';
			$scope.feedbackImg = '';
			$scope.showFeedback = false;
			$scope.showFeedbackPopup = false;
			$scope.showRetake = false;
			$scope.bubbletext1 = false;
			$scope.bubbletext2 = false;
			$scope.showReturn = false;
			var cName = '';
			var tempC = '';
			$scope.checkSlider = function () {
				if ($scope.slide == 2) {
					$scope.slide = 3;
				}
				if ($scope.slide == 1) {
					$scope.bubbletext1 = true;
					$scope.bubbletext2 = false;
					$scope.showReturn = false;
					$scope.feedback = $rootScope.CourseContent.slides[0].text;
				} else if ($scope.slide == 3) {
					$scope.bubbletext1 = false;
					$scope.bubbletext2 = true;
					$scope.showReturn = true;
					$rootScope.markVisitedPage();
					$scope.feedback = $rootScope.CourseContent.slides[1].text;
				}
				else {
					$scope.showReturn = false;
					$scope.bubbletext1 = false;
					$scope.bubbletext2 = false;
				}
				cName = 'slider_' + $scope.slide;
				$('.slider-area').removeClass(tempC).addClass(cName);
				tempC = 'slider_' + $scope.slide;

			}

			$scope.changeSlide = function (i) {
				$scope.slide = i;
				cName = 'slider_' + $scope.slide;
				$('.slider-area').removeClass(tempC).addClass(cName);
				tempC = 'slider_' + $scope.slide;
				$scope.checkSlider();
			}

			$scope.return = function () {
				$scope.gotoNextPage();
			}
			$scope.closeFedBack = function () {
				$scope.showFeedbackPopup = false;
			}
		}
	}
});
FrameworkApp.directive('conversation', function () {
	return {
		restrict: 'A',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope, $timeout, $interval) {
			var count = 0;
			var cnvrnTimer = null;
			var isPlaying = false;
			var sbBtClcked = [];
			$scope.isPlaying = isPlaying;
			$scope.visitedArray = [];
			$scope.c = 0;
			$scope.subPopup = false;
			$scope.showSbPP = false;
			$scope.page1 = true;
			$scope.openHotword = false;
			$scope.hotwordText = '';
			$scope.popupText = '';
			$scope.visitedStts = false;
			$scope.visitedArray.push(0);
			if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == "1") {
				$scope.visitedStts = true;
			}
			$scope.checkState = function (i) {
				if (i > $scope.c + 1 && $scope.visitedArray.indexOf(i) == -1 && $rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == "0") {
					return "disabled";
				}
				if (i == $scope.c) {
					return "activebtn";
				}
			};

			function startScreen() {
				cnvrnTimer = $interval(function () {
					count++;
					var getTime = $rootScope.CourseContent.screen[$scope.c].timer ? $rootScope.CourseContent.screen[$scope.c].timer : 2;
					getTime = parseInt(getTime);
					var isSubBtn = $rootScope.CourseContent.screen[$scope.c].subBtn;
					if (isSubBtn) {
						$scope.isPlaying = false;
						isPlaying = false;
						$interval.cancel(cnvrnTimer);
					}
					if ($scope.visitedArray.indexOf($scope.c) == -1)
						$scope.visitedArray.push($scope.c);
					if (count >= getTime && !isSubBtn) {
						$('.speach-bubble').fadeOut(300, function () {
							$scope.c++;
							$scope.$apply();
							$('.speach-bubble').fadeIn(500);
						});
						sbBtClcked = [];
						$scope.showSbPP = false;
						if ($scope.c >= $rootScope.CourseContent.screen.length)
							$scope.c = 0;
						count = 0;
					}
					chkCompletion();
				}, 1000);
			}

			$scope.getcCntent = function (i) {
				if (!$rootScope.CourseContent.screen[0].subBtn && $scope.visitedArray.indexOf(0) == -1)
					$scope.visitedArray.push(0);
				$('.speach-bubble').fadeOut(300, function () {
					$scope.c = i;
					$scope.$apply();
					$('.speach-bubble').fadeIn(500);
				});
				var isSubBtn = $rootScope.CourseContent.screen[i].subBtn;
				count = 0;
				if (isSubBtn) {
					$scope.isPlaying = false;
					isPlaying = false;
					$interval.cancel(cnvrnTimer);
				}
				if ($scope.visitedArray.indexOf(i) == -1 && !isSubBtn)
					$scope.visitedArray.push(i);
				chkCompletion();
				$scope.showSbPP = false;
				$scope.subPopup = false;
			};

			var inside = false;
			$scope.gNext = function () {
				if ($scope.c < $rootScope.CourseContent.screen.length - 1 && !inside) {
					inside = true;
					$('.speach-bubble').fadeOut(300, function () {
						$scope.c++;
						inside = false;
						i = $scope.c;
						var isSubBtn = $rootScope.CourseContent.screen[i].subBtn;
						if ($scope.visitedArray.indexOf(i) == -1 && !isSubBtn)
							$scope.visitedArray.push(i);
						chkCompletion();
						$scope.$apply();
						$('.speach-bubble').fadeIn(500);
					});
				}
			};

			//var inside = false;
			$scope.gPrev = function () {
				if ($scope.c > 0 && !inside) {
					inside = true;
					$('.speach-bubble').fadeOut(300, function () {
						$scope.c--;
						inside = false;
						var i = $scope.c;
						var isSubBtn = $rootScope.CourseContent.screen[i].subBtn;
						if ($scope.visitedArray.indexOf(i) == -1 && !isSubBtn)
							$scope.visitedArray.push(i);
						$scope.$apply();
						$('.speach-bubble').fadeIn(500);
					});
				}
			}

			function chkCompletion() {
				var isCompleted = $scope.visitedArray.length >= $rootScope.CourseContent.screen.length;

				if (isCompleted) {
					$rootScope.markVisitedPage();
					$scope.isPlaying = false;
					isPlaying = false;
					return true;
				} else {
					return false;
				}
			}
			$scope.loadcontent =function(event,item){
				$scope.subPopup = true;
				$scope.popupText = item.text;
				$(event.currentTarget).addClass('visited');
			}
			$scope.showvisited = false;
			$scope.closePopup=function(){
				$scope.subPopup = false;
				$scope.showvisited = true;
			}

			$scope.openSubPopup = function (ind, item, isObj) {
				$(event.currentTarget).addClass("selected-answer");
				$scope.subPopup = true;
				$scope.popupText = item.popupText;
				var sbBtnCnt = $rootScope.CourseContent.screen[$scope.c].subBtn;
				sbBtnCnt = parseInt(sbBtnCnt);
				if (sbBtClcked.indexOf(ind) == -1)
					sbBtClcked.push(ind);
				if (sbBtClcked.length >= sbBtnCnt) {
					if ($scope.visitedArray.indexOf($scope.c) == -1)
						$scope.visitedArray.push($scope.c);
				}
				chkCompletion();
			};

			$scope.closeSub = function () {
				$scope.subPopup = false;
				var isSubBtn = $rootScope.CourseContent.screen[$scope.c].subBtn;
				var sbBtnCnt = $rootScope.CourseContent.screen[$scope.c].subBtn;
				sbBtnCnt = parseInt(sbBtnCnt);
			};

			$scope.hotword = function (key, id, itemNum) {
				$scope.openHotword = true;
				$scope.hotwordText = $rootScope.CourseContent[key];
				if (itemNum) {
					var sbBtnCnt = $rootScope.CourseContent.screen[itemNum].subBtn;
				} else {
					var sbBtnCnt = $rootScope.CourseContent.screen[$scope.c].subBtn;
				}
				sbBtnCnt = parseInt(sbBtnCnt);
				if (sbBtClcked.indexOf(id) == -1)
					sbBtClcked.push(id);
				if (sbBtClcked.length >= sbBtnCnt) {
					if (itemNum) {
						if ($scope.visitedArray.indexOf(itemNum) == -1)
							$scope.visitedArray.push(itemNum);
					}
					else if ($scope.visitedArray.indexOf($scope.c) == -1)
						$scope.visitedArray.push($scope.c);
					chkCompletion();
				}
			}

			$scope.closeHotword = function (key) {
				$scope.openHotword = false;
				$scope.hotwordText = '';
			};

			$scope.sbPop = function () {
				$(event.currentTarget).addClass("selected-answer");
				$scope.showSbPP = true;
				$scope.visitedStts = true;
				if ($scope.visitedArray.indexOf($scope.c) == -1)
					$scope.visitedArray.push($scope.c);
				chkCompletion();
			}
			$scope.closeSbPop = function () {
				$scope.showSbPP = false;
			}

			$scope.$on('$destroy', function () {
				$interval.cancel(cnvrnTimer)
			});
		}
	}
});

FrameworkApp.directive('conversation5', function () {
	return {
		restrict: 'A',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope, $timeout, $interval) {
			var count = 0;
			var cnvrnTimer = null;
			var isPlaying = false;
			var sbBtClcked = [];
			$scope.isPlaying = isPlaying;
			$scope.visitedArray = [];
			$scope.c = 0;
			$scope.subPopup = false;
			$scope.showSbPP = false;
			$scope.page1 = true;
			$scope.openHotword = false;
			$scope.hotwordText = '';
			$scope.popupText = '';
			$scope.visitedStts = false;
			$scope.visitedArray.push(0);
			if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == "1") {
				$scope.visitedStts = true;
			}
			$scope.checkState = function (i) {
				if (i > $scope.c + 1 && $scope.visitedArray.indexOf(i) == -1 && $rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == "0") {
						return "disabled";
				}
				// if(i == 2){
				// 	if($scope.popupvstd == false){
				// 		return "disabled";
				// 	}
				// }
				if (i == $scope.c) {
						return "activebtn";
					
				}
			};

			function startScreen() {
				cnvrnTimer = $interval(function () {
					count++;
					var getTime = $rootScope.CourseContent.screen[$scope.c].timer ? $rootScope.CourseContent.screen[$scope.c].timer : 2;
					getTime = parseInt(getTime);
					var isSubBtn = $rootScope.CourseContent.screen[$scope.c].subBtn;
					if (isSubBtn) {
						$scope.isPlaying = false;
						isPlaying = false;
						$interval.cancel(cnvrnTimer);
					}
					if ($scope.visitedArray.indexOf($scope.c) == -1)
						$scope.visitedArray.push($scope.c);
					if (count >= getTime && !isSubBtn) {
						$('.speach-bubble').fadeOut(300, function () {
							$scope.c++;
							$scope.$apply();
							$('.speach-bubble').fadeIn(500);
						});
						sbBtClcked = [];
						$scope.showSbPP = false;
						if ($scope.c >= $rootScope.CourseContent.screen.length)
							$scope.c = 0;
						count = 0;
					}
					chkCompletion();
				}, 1000);
			}

			$scope.getcCntent = function (i) {
				if (!$rootScope.CourseContent.screen[0].subBtn && $scope.visitedArray.indexOf(0) == -1)
					$scope.visitedArray.push(0);
				$('.speach-bubble').fadeOut(300, function () {
					$scope.c = i;
					$scope.$apply();
					$('.speach-bubble').fadeIn(500);
				});
				var isSubBtn = $rootScope.CourseContent.screen[i].subBtn;
				count = 0;
				if (isSubBtn) {
					$scope.isPlaying = false;
					isPlaying = false;
					$interval.cancel(cnvrnTimer);
				}
				if ($scope.visitedArray.indexOf(i) == -1 && !isSubBtn)
					$scope.visitedArray.push(i);
				chkCompletion();
				$scope.showSbPP = false;
				$scope.subPopup = false;
			};

			
			var inside = false;
			$scope.gNext = function () {
				if ($scope.c < $rootScope.CourseContent.screen.length - 1 && !inside) {
					inside = true;
					$('.speach-bubble').fadeOut(300, function () {
						$scope.c++;
						inside = false;
						i = $scope.c;
						var isSubBtn = $rootScope.CourseContent.screen[i].subBtn;
						if ($scope.visitedArray.indexOf(i) == -1 && !isSubBtn)
							$scope.visitedArray.push(i);
						chkCompletion();
						$scope.$apply();
						$('.speach-bubble').fadeIn(500);
					});
				}
			};

			//var inside = false;
			$scope.gPrev = function () {
				if ($scope.c > 0 && !inside) {
					inside = true;
					$('.speach-bubble').fadeOut(300, function () {
						$scope.c--;
						inside = false;
						var i = $scope.c;
						var isSubBtn = $rootScope.CourseContent.screen[i].subBtn;
						if ($scope.visitedArray.indexOf(i) == -1 && !isSubBtn)
							$scope.visitedArray.push(i);
						$scope.$apply();
						$('.speach-bubble').fadeIn(500);
					});
				}
			}

			function chkCompletion() {
				var isCompleted = $scope.visitedArray.length >= $rootScope.CourseContent.screen.length;

				if (isCompleted && $scope.popupvstd) {
					$rootScope.markVisitedPage();
					$scope.isPlaying = false;
					isPlaying = false;
					return true;
				} else {
					return false;
				}
			}
			$scope.popupvstd = false;
			$scope.loadcontent =function(event,item){
				$scope.subPopup = true;
				$scope.popupvstd = true;
				$scope.popupText = item.text;
				$(event.currentTarget).addClass('visited');
				chkCompletion();
			}
			$scope.showvisited = false;
			$scope.closePopup=function(){
				$scope.subPopup = false;
				$scope.showvisited = true;
			}

			$scope.openSubPopup = function (ind, item, isObj) {
				$(event.currentTarget).addClass("selected-answer");
				$scope.subPopup = true;
				$scope.popupText = item.popupText;
				var sbBtnCnt = $rootScope.CourseContent.screen[$scope.c].subBtn;
				sbBtnCnt = parseInt(sbBtnCnt);
				if (sbBtClcked.indexOf(ind) == -1)
					sbBtClcked.push(ind);
				if (sbBtClcked.length >= sbBtnCnt) {
					if ($scope.visitedArray.indexOf($scope.c) == -1)
						$scope.visitedArray.push($scope.c);
				}
				chkCompletion();
			};

			$scope.closeSub = function () {
				$scope.subPopup = false;
				var isSubBtn = $rootScope.CourseContent.screen[$scope.c].subBtn;
				var sbBtnCnt = $rootScope.CourseContent.screen[$scope.c].subBtn;
				sbBtnCnt = parseInt(sbBtnCnt);
			};

			$scope.hotword = function (key, id, itemNum) {
				$scope.openHotword = true;
				$scope.hotwordText = $rootScope.CourseContent[key];
				if (itemNum) {
					var sbBtnCnt = $rootScope.CourseContent.screen[itemNum].subBtn;
				} else {
					var sbBtnCnt = $rootScope.CourseContent.screen[$scope.c].subBtn;
				}
				sbBtnCnt = parseInt(sbBtnCnt);
				if (sbBtClcked.indexOf(id) == -1)
					sbBtClcked.push(id);
				if (sbBtClcked.length >= sbBtnCnt) {
					if (itemNum) {
						if ($scope.visitedArray.indexOf(itemNum) == -1)
							$scope.visitedArray.push(itemNum);
					}
					else if ($scope.visitedArray.indexOf($scope.c) == -1)
						$scope.visitedArray.push($scope.c);
					chkCompletion();
				}
			}

			$scope.closeHotword = function (key) {
				$scope.openHotword = false;
				$scope.hotwordText = '';
			};

			$scope.sbPop = function () {
				$(event.currentTarget).addClass("selected-answer");
				$scope.showSbPP = true;
				$scope.visitedStts = true;
				if ($scope.visitedArray.indexOf($scope.c) == -1)
					$scope.visitedArray.push($scope.c);
				chkCompletion();
			}
			$scope.closeSbPop = function () {
				$scope.showSbPP = false;
			}

			$scope.$on('$destroy', function () {
				$interval.cancel(cnvrnTimer)
			});
		}
	}
});

FrameworkApp.directive('conversationwithstart', function () {
	return {
		restrict: 'A',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope, $timeout, $interval) {
			var count = 0;
			var cnvrnTimer = null;
			var isPlaying = false;
			$scope.isPlaying = isPlaying;
			$scope.visitedArray = [];
			$scope.c = 0;
			$scope.subPopup = false;
			$scope.page1 = true;
			$scope.popupText = '';
			$scope.visitedArray.push($scope.c);
			$scope.checkState = function (i) {
				if (i > $scope.c + 1 && $scope.visitedArray.indexOf(i) == -1 && $rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == "0") {
					return "disabled";
				}
				if (i == $scope.c) {
					return "activebtn";
				}
			};

			function startScreen() {
				cnvrnTimer = $interval(function () {
					count++;
					var getTime = $rootScope.CourseContent.screen[$scope.c].timer ? $rootScope.CourseContent.screen[$scope.c].timer : 2;
					getTime = parseInt(getTime);
					if (count >= getTime) {
						$scope.c++;
						if ($scope.c >= $rootScope.CourseContent.screen.length)
							$scope.c = 0;
						if ($scope.visitedArray.indexOf($scope.c) == -1)
							$scope.visitedArray.push($scope.c);
						count = 0;
						chkCompletion();
					}
				}, 1000);
			}

			$scope.screenPlay = function () {
				$scope.page1 = false;
				$scope.isPlaying = isPlaying;
			};

			$scope.closeP1 = function () {
				$scope.page1 = true;
				$scope.c = 0;
			}

			$scope.getcCntent = function (i) {
				$scope.c = i;
				count = 0;
				if ($scope.visitedArray.indexOf($scope.c) == -1)
					$scope.visitedArray.push($scope.c);
				chkCompletion();
			}

			$scope.gNext = function () {
				if ($scope.c < $rootScope.CourseContent.screen.length - 1) {
					$scope.c++;
					var i = $scope.c;
					var isSubBtn = $rootScope.CourseContent.screen[i].subBtn;
					if ($scope.visitedArray.indexOf(i) == -1 && !isSubBtn)
						$scope.visitedArray.push(i);
					chkCompletion();
				}
			};

			$scope.gPrev = function () {
				if ($scope.c > 0) {
					$scope.c--;
					var i = $scope.c;
					var isSubBtn = $rootScope.CourseContent.screen[i].subBtn;
					if ($scope.visitedArray.indexOf(i) == -1 && !isSubBtn)
						$scope.visitedArray.push(i);
				}
			}

			function chkCompletion() {
				var isCompleted = $scope.visitedArray.length >= $rootScope.CourseContent.screen.length;
				if (isCompleted) {
					$rootScope.markVisitedPage();
					$scope.isPlaying = false;
					isPlaying = false;
					$interval.cancel(cnvrnTimer);
				}
			}

			$scope.openSubPopup = function (ind, item) {
				$scope.subPopup = true;
				$scope.popupText = item.popupText;
			};

			$scope.closeSub = function () {
				$scope.subPopup = false;
			};

			$scope.$on('$destroy', function () {
				$interval.cancel(cnvrnTimer)
			});
		}
	}
});


FrameworkApp.directive('createScenario', function () {
	return {
		restrict: 'AC',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope, $timeout, $interval) {
			$scope.stopAnimation = false;
			$scope.disableBtns = true;
			$timeout(function () {
				$scope.disableBtns = false;
			}, 6000);
			$scope.checkFilled = function (start, end) {
				var newArray = $rootScope.pageStatusList[$rootScope.currentTopic].slice(start, end);
				if (newArray.indexOf('1') != -1) {
					$scope.stopAnimation = true;
					$scope.disableBtns = false;
					$rootScope.isAudio = false;
					if ($rootScope.CourseContent.branchingScreen && ($rootScope.isAudio == false)) {
						$rootScope.transcript = false;
					}
				}
			}
			/* $rootScope.isTranscriptClose=$rootScope.CourseContent.branchingScreen */

			// checkFilled();
			$scope.loadScenarionScreen = function (ind, item) {
				var pID = item.gotPage.split("_");
				var m = parseInt(pID[0]);
				m--;
				var t = parseInt(pID[1]);
				t--;
				var c = parseInt(pID[2]);
				c--;
				$rootScope.loadScreen(m, t, c);
			};
			var completed = false;
			$scope.checkCompleteion = function (ind, item) {
				var status = "";
				var pID = item.gotPage.split("_");
				var c = parseInt(pID[2]);
				var pEndID = item.scnEnds.split("_");
				var cE = parseInt(pEndID[2]);
				var anyOneCompleted = false;
				var allCompleted = false;
				var sliceList = $rootScope.pageStatusList[$rootScope.currentTopic].slice(c - 1, cE - 1);
				allCompleted = (sliceList.indexOf("0") == -1);
				anyOneCompleted = (sliceList.indexOf("1") >= 0);
				if (allCompleted) {
					status = "sc-visited";
				} else if (anyOneCompleted) {
					status = "sc-in-progress";
				} else {
					status = "sc-not-started";
				}
				if ($('.sc-visited').length == $rootScope.CourseContent.scenario.length && !completed) {
					$rootScope.markVisitedPage();
					$rootScope.isNextButtonDisabled = false;
					completed = true;
				}
				if (ind > 0 && status != "sc-visited" && !$('.btn_' + ind).hasClass('sc-visited')) {
					if ($rootScope.CourseConfig.ForceNavigation)
						status += " disable-scenario";
				}
				return status;
			}
		}
	}
});

FrameworkApp.directive('formvalidate', function () {
	return {
		restrict: 'A',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope) {
			$scope.cantContinue = true;
			$scope.page = 1;
			$scope.fName = '';
			$scope.employeeNum = '';
			$scope.country = '';
			$scope.customer = '';
			$scope.distributor = '';
			$scope.competitor = '';
			$scope.prsnl_rlnshp = '';
			$scope.any_relative = '';
			$scope.coi_brg = '';
			$scope.pNC = '';
			$scope.brfDscrp = '';
			$scope.Company = '';
			$scope.Location = '';
			$scope.date = '';
			var glblYsExist = false;
			var userData = {};
			$scope.checkFilled = function (e) {
				if ($scope.fName.length > 0 && $scope.employeeNum.toString().length > 0 && $scope.country.length > 0) {
					$scope.cantContinue = false;
				}
				else {
					$scope.cantContinue = true;
				}
			};

			$scope.checkFilled2 = function () {
				if ($scope.pNC.length > 0 && $scope.brfDscrp.length > 0 && $scope.Company.length > 0 && $scope.Location.length > 0) {
					$scope.cantContinue = false;
				}
				else {
					$scope.cantContinue = true;
				}
			};
			$scope.checkRadio = function () {
				$(event.target).parent().siblings('label').removeClass('option-selected');
				$(event.target).parent().addClass('option-selected');
				var dataKey = $(event.target).parents('form').data('key');
				userData[dataKey] = $(event.target).val();
				if ($scope.customer && $scope.distributor && $scope.competitor) {
					$scope.cantContinue = false;
				}
				if ($scope.customer.toLowerCase() == 'yes' || $scope.distributor.toLowerCase() == "yes" || $scope.competitor.toLowerCase() == "yes") {
					glblYsExist = true;
				} else {
					glblYsExist = false;
				}
			};

			$scope.checkRadio2 = function () {
				$(event.target).parent().siblings('label').removeClass('option-selected');
				$(event.target).parent().addClass('option-selected');
				var dataKey = $(event.target).parents('form').data('key');
				userData[dataKey] = $(event.target).val();
				if ($scope.prsnl_rlnshp && $scope.any_relative && $scope.coi_brg) {
					$scope.cantContinue = false;
				}
				if (!glblYsExist) {
					if ($scope.prsnl_rlnshp.toLowerCase() == 'yes' || $scope.any_relative.toLowerCase() == "yes" || $scope.coi_brg.toLowerCase() == "yes") {
						glblYsExist = true;
					} else {
						glblYsExist = false;
					}
				}
			};

			$scope.goNext = function () {
				$scope.cantContinue = true;
				$scope.page++;
				if ($scope.page == 4 && !glblYsExist) {
					$scope.page++;
				}
			};

			$scope.declare = function () {
				$(event.currentTarget).addClass('disabled');
				userData.fName = $scope.fName;
				userData.employeeNum = $scope.employeeNum;
				userData.country = $scope.country;
				userData.pNC = $scope.pNC;
				userData.brfDscrp = $scope.brfDscrp;
				userData.Company = $scope.Company;
				userData.Location = $scope.Location;

				var today = new Date();
				var dd = today.getDate();
				var mm = today.getMonth() + 1; //January is 0!
				var yyyy = today.getFullYear();
				if (dd < 10) {
					dd = '0' + dd
				}
				if (mm < 10) {
					mm = '0' + mm
				}
				today = dd + '/' + mm + '/' + yyyy;
				userData.date = today;
				userData = JSON.stringify(userData);
				console.log(userData);
				$rootScope.isPassed[6] = userData;
				$rootScope.markVisitedPage();
			}
		}
	}
});



FrameworkApp.directive('introControl', function () {
	return {
		restrict: 'A',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope, $timeout) {
			$scope.page2 = true;
			$scope.skipVideo = false;
			var vdo = document.getElementById("introVideo");
			vdo.load();
			$(".play-btn").removeClass("disableVideoPlayBtn");
			$(".play_icon").css("background-color", "#ffd500");
			$scope.showPlayBtn = true;
			$scope.playVideo = function (_id) {
				if (_id) {
					document.getElementById(_id).setAttribute('controls', true);
					document.getElementById(_id).play();
				} else {
					vdo.setAttribute('controls', true)
					vdo.play();
				}
				$scope.showPlayBtn = false;
				$scope.skipVideo = true;
			};
			vdo.addEventListener('ended', function () {
				$timeout(function () {
					$scope.startcourseFromIntro();
					$scope.$apply();
				});
			});

		}
	}
});
FrameworkApp.directive('videoDirective', function () {
	return {
		restrict: 'A',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope, $timeout) {

			var vdo = document.getElementById("vid_6_1");
			vdo.load();

			$scope.showPlayBtn = true;
			$scope.playVideo = function (_id) {
				if (_id) {
					document.getElementById(_id).setAttribute('controls', true)
					document.getElementById(_id).play();
				} else {
					vdo.setAttribute('controls', true)
					vdo.play();
				}
				$scope.showPlayBtn = false;
				$(".audio-btn").addClass("disablePlay");
				/* $(".replayBtn").addClass("disablePlay"); */
			};
			/* $timeout(function(){
				vdo.play();
			},2500); */

		}
	}
});
FrameworkApp.directive('vdocontrol', function () {
	return {
		restrict: 'A',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope, $timeout) {
			$scope.openHotword = false;
			$scope.playVideo = function () {
				$scope.openHotword = true;
				var a = document.getElementById('videoBox');
				setTimeout(function () {
					a.load();
					a.setAttribute('controls', true)
					a.play();
					a.addEventListener("ended", function () {
						$rootScope.markVisitedPage();
						$rootScope.$apply();
					});
				}, 1000);
				//pauseAudio();
			}
			$scope.closeVideo = function () {
				var a = document.getElementById('videoBox');
				a.pause();
				$scope.openHotword = false;
				//plAudio();
			}
		}
	}
});

FrameworkApp.directive('fdOut', function () {
	return {
		restrict: 'A',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope, $timeout) {
			$scope.page1 = true;
			$timeout(function () {
				$scope.page1 = false;
				//alert($('.characters,.p1'))
				$('.characters,.p1').removeClass('fadeIn,animated');
				$('.characters,.speach-bubble').fadeOut(1000, function () {
					$('.characters_02,.p2').fadeIn(1000);
				});
			}, 8000);
		}
	}
});


// New directive added by Shiva

//Directive to implement Button Click Type14
FrameworkApp.directive('btnClickType14', function () {
	return {
		restrict: 'C',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope, $timeout) {
			var counter = 0;
			$scope.popupToggle = false;
			$scope.subBtn = false;
			//$scope.subPopup = false;
			$scope.visitedStts = false;
			var tempVisited = '';
			var adedCls = '';

			if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == "1") {
				$scope.visitedStts = true;
			}
			$rootScope.clickCounter = [];
			if ($rootScope.clickCounter.indexOf($scope.active) == -1 && $scope.active != undefined)
				$rootScope.clickCounter.push($scope.active);
			$scope.loadcontent = function (event, pItem) {
				$(".btns").removeClass("selected");

				if (navigator.onLine == false) {
					$rootScope.checkInternet($rootScope.selectedLang);
					return false;
				}

				$scope.popupToggle = true;
				$scope.active = pItem.id;
				if ($rootScope.clickCounter.indexOf($scope.active) == -1)
					$rootScope.clickCounter.push($scope.active);
				$rootScope.Buttontext = pItem.text;
				$rootScope.header = pItem.button;
				if ($rootScope.clickCounter.length == $rootScope.CourseContent.btn_click_learn.length && $rootScope.CourseContent.noTracking != 'true')
					$rootScope.markVisitedPage();
				if ($rootScope.clickCounter.length == $rootScope.CourseContent.btn_click_learn.length)
					$scope.subBtn = true;
				$(event.currentTarget).addClass("selected");
				$(event.currentTarget).addClass("visited");
				tempVisited = event.currentTarget;
				$(".btn_content").removeClass(adedCls);
				$(".btn_content").addClass("btn_content" + pItem.id);
				adedCls = "btn_content" + pItem.id;
			}
			$scope.openPopUp14 = function () {
				$rootScope.checkInternet($rootScope.selectedLang);

			}
			$scope.closePopup = function () {
				if (!navigator.onLine) {
					$rootScope.checkInternet($rootScope.selectedLang);
					return;
				}
				$scope.popupToggle = false;
				//console.log(tempVisited)
				//$(tempVisited).removeClass("selected");
				$(".btns").removeClass("selected");
				$(tempVisited).addClass("visited");
			}
		}
	}
});


//Directive to implement Carousel Navigation
FrameworkApp.directive('carouselNav', function () {
	return {
		restrict: 'C',
		link: function ($scope, $rootScope, $timeout, elem, attrs) {
		},
		controller: function ($scope, $rootScope) {

			$('#myCarousel').carousel({
				wrap: false
			});
			if ($rootScope.isPassed[4] == 0 && $rootScope.currentPage == 2 && $rootScope.currentTopic == 5) {
				$rootScope.isNextButtonDisabled = true;
			}

			$scope.counter = 0;
			$scope.clickCounter = [];
			setTimeout(function () {
				if ($rootScope.CourseContent.subBtns == true || $rootScope.CourseContent.subBtns == "true") {

				} else {
					if ($scope.clickCounter.indexOf(0) == -1)
						$scope.clickCounter.push(0);
				}
			}, 500);

			var _hyperLink = false;
			var subBtn = 0;
			$scope.additionalpopupToggle = false;
			$scope.navigatePage = function (nav) {

				$rootScope.checkInternet($rootScope.selectedLang);
				if (nav == 'next') {
					$('#myCarousel').carousel("next");
					$scope.counter++;
					if ($scope.counter == 4) {
						$scope.additionalpopupToggle = true;
					}
					var _ele = $('.carousel-indicators').find('li');
					$(_ele[$scope.counter + 1]).removeClass('disabled');
					console.log($scope.counter)
					$(_ele[$scope.counter - 1]).addClass('visited');
					//if($scope.counter == $rootScope.CourseContent.btn_content.length-1){
					$(_ele[$scope.counter]).addClass('visited');
					//}
				} else {
					$('#myCarousel').carousel("prev");
					$scope.counter--;
				}
				if ($scope.counter > 0) {
					setTimeout(function () {
						$('.left').css("pointer-events", "all");
					}, 800);
					$('.left').css("opacity", "1");
				} else {
					$('.left').css("pointer-events", "none");
					$('.left').css("opacity", "0.5");
				}

				if ($rootScope.CourseContent.btn_content.length == $scope.counter + 1) {
					$('.right').css("pointer-events", "none");
					$('.right').css("opacity", "0.5");
				} else {
					setTimeout(function () {
						$('.right').css("pointer-events", "all");
					}, 800);
					$('.right').css("opacity", "1");
				}
				var sbBtns = $rootScope.CourseContent.btn_content[$scope.counter].sub_btn ? $rootScope.CourseContent.btn_content[$scope.counter].sub_btn : 0;
				if (parseInt(sbBtns) <= 0) {
					$scope.checkCompletion();
				}
				$(".right").css("pointer-events", "none");
				$(".left").css("pointer-events", "none");
				$(".item").css("pointer-events", "all");
				$(".item").removeClass("done");
				$(".item").removeClass("done");
			};

			$scope.trackBtns = function (_val) {
				if ($scope.clickCounter.indexOf(_val) == -1) {
					$scope.clickCounter.push(_val);
					$scope.checkCompletion();
				}
				if (_val == 0) {
					$('.left').css("pointer-events", "none");
					$('.left').css("opacity", "0.5");
				} else {
					$('.left').css("pointer-events", "all");
					$('.left').css("opacity", "1");
				}
				if (_val == $rootScope.CourseContent.btn_content.length - 1) {
					$('.right').css("pointer-events", "none");
					$('.right').css("opacity", "0.5");
				} else {
					$('.right').css("pointer-events", "all");
					$('.right').css("opacity", "1");
				}
				var _ele = $('.carousel-indicators').find('li');
				console.log(_ele)
				$(_ele[_val + 1]).removeClass('disabled');
				$(_ele[$scope.counter]).addClass('visited');
				$scope.counter = _val;
				$(_ele[$scope.counter]).addClass('visited');
				console.log(_val)
			};

			$scope.checkCompletion = function () {
				if ($scope.clickCounter.indexOf($scope.counter) == -1) {
					$scope.clickCounter.push($scope.counter);
				}
				if ($scope.clickCounter.length == $rootScope.CourseContent.btn_content.length) {
					$rootScope.markVisitedPage();
					console.log($rootScope.CourseContent.markNextScreen)
					if ($rootScope.CourseContent.markNextScreen == "true")
						$rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage + 1] = "1";
					console.log($rootScope.pageStatusList[$rootScope.currentTopic])
				}
			}

		}
	}
});


FrameworkApp.directive('audioSync', function () {
	return {
		restrict: 'A',
		link: function (scope, $rootScope, elem, attrs) {
			var num = scope.$eval(attrs.exampleNumber);
		},
		controller: function ($scope, $rootScope, $interval, $timeout) {
			var i = 0;
			$interval.cancel(getAnimateElement);
			var animatable = $("body").find("[data-animate]");
			$(animatable).hide();
			if ($rootScope.audioFile) {
				var audio = $rootScope.audioFile,
					current = audio.currentTime;
				var getAnimateElement = $interval(function () {
					var animatable = $("body").find("[data-animate]");
					if (animatable.length > 0) {
						if (!$rootScope.audioFile.ended)
							$(animatable).hide();
						$rootScope.promiseAudio = $interval(function () { syncObject(animatable) }, 10);
						$interval.cancel(getAnimateElement);
					}
				}, 50);
			}

			var showGuid = false;
			function syncObject(animatable) {
				if ($rootScope.isPpAudioPlaying) {
					$interval.cancel($rootScope.promiseAudio);
					return;
				}
				$scope.cTime = audio.currentTime;
				var crntTme = audio.currentTime;

				for (var i = 0; i <= animatable.length; i++) {
					var animStart = $($(animatable)[i]).attr("data-animation-start");
					var animEnd = $($(animatable)[i]).attr("data-animation-end");

					if (crntTme >= animEnd) {
						var fdOtType = $($(animatable)[i]).attr("data-fadeout");
						if (fdOtType) {
							$($(animatable)[i]).addClass(fdOtType);
						}
						else {
							$($(animatable)[i]).fadeOut();
						}
					}
					else if (crntTme >= animStart) {
						var animType = $($(animatable)[i]).attr("data-animate-type");
						var stpAudio = $($(animatable)[i]).attr("data-animation-stop");
						var showIntGuide = $($(animatable)[i]).attr("data-show-guide");
						$($(animatable)[i])
							.fadeIn()
							.addClass("animated " + animType);
						if (stpAudio == "true") {
							$rootScope.audioFile.pause();
							$($(animatable)[i]).attr("data-animation-stop", "false");
							$rootScope.isPaused = true;
							$(".pause-btn").removeClass('btnEnabled').addClass('btnDisabled');
						}
						/* if(showIntGuide == "true" && !showGuid){
							$rootScope.showInterviewGuide = true;	
							$rootScope.intGuideEase = false;
							$timeout(function(){
								$rootScope.intGuideEase = true;
								$(".ease-in-bottom").css("display","none");
							},3000);
							showGuid = true;
						} */
					}
					/* else{
						$($(animatable)[i]).hide();
					} */
					if ($rootScope.audioFile.ended) {
						break;
					}
				}
				if ($rootScope.audioFile.ended) {
					$interval.cancel($rootScope.promiseAudio);
					return;
				}

				/* if($rootScope.isAudio == 'false'){
					$interval.cancel($rootScope.promiseAudio);
					$(animatable).show();
					return;
				} */
			}

			$scope.$on("$destroy", function () {
				if ($rootScope.promiseAudio) {
					$interval.cancel($rootScope.promiseAudio);
				}
				if (getAnimateElement) {
					$interval.cancel(getAnimateElement);
				}
			});
		}
	}
});
FrameworkApp.directive('btnClickType15', function () {
	var tempVisited = '';
	var cClass = '';
	return {
		restrict: 'CA',
		link: function ($scope, $rootScope, elem, attrs) {
			tempVisited = '';
		},
		controller: function ($scope, $rootScope, $timeout, $interval) {
			$rootScope.showPopUp = false;
			if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == "1") {
				$(".btnClickType30").addClass("visited");
				$(".btnClickType15").addClass("visited");
				$rootScope.showPopUp = true;
				$scope.visitedStts = true;
				/* if($rootScope.isPassed[4] == 0 && $rootScope.currentTopic == 5 && ($rootScope.currentPage == 3 || $rootScope.currentPage == 4)){
					$rootScope.isNextButtonDisabled = true;
					$(".btnClickType3").removeClass("visited");
				} */
			}
			var tempVisit = '';
			var counter = 0;
			$rootScope.clicked = false;
			$rootScope.openpopupType3 = false;
			$scope.active = 1;
			$rootScope.count = 1;
			$scope.tCount = 0;
			$rootScope.clickCounter = [];
			$(".accordian-panel").hide();
			$rootScope.ButtontextType3 = '';
			var track = true;
			$scope.foot1 = false;
			$scope.foot2 = false;
			$scope.loadcontent = function (event, pItem, _type, tracking) {
				if (tracking)
					track = tracking;
				$rootScope.checkInternet($rootScope.selectedLang);
				$rootScope.openpopupType3 = true;
				$(".accordian-panel").show();
				$rootScope.count = parseInt(pItem.id);
				$('.btnClickType15').removeClass("selected");
				$(event.currentTarget).addClass("selected");
				var flag = $('.clickables');
				if (!$(flag[0]).hasClass("markCompleted"))
					$(flag[0]).addClass("markCompleted");
				$(flag[pItem.id - 1]).removeClass("markCompleted");
				$(tempVisit).addClass("markCompleted");
				tempVisit = $(flag[pItem.id - 1]);
				$(".btnClickType30").removeClass("selected");
				$($(".btnClickType30")[$rootScope.count - 1]).addClass("selected");
				$rootScope.ButtontextType3 = pItem.text;
				$rootScope.clicked = true;
				$scope.checkCompletion($rootScope.count - 1);
				tempVisited = $(event.currentTarget);
				/* if($rootScope.clickCounter.length > 0){ */
				$(tempVisited).addClass("visited");
				/* } */
				if (_type === "cType") {
					if ($rootScope.clickCounter.indexOf(0) == -1) {
						$rootScope.clickCounter.push(0);
					}
				}
				$('.accordian-panel').removeClass(cClass);
				$('.accordian-panel').addClass('accordian_' + pItem.id);
				cClass = 'accordian_' + pItem.id;
				$('.foot_img' + (parseInt(pItem.id) - 1)).show();
			}
			$rootScope.close = function (val) {
				// Temp code
				if (val == 'exit') {
					$rootScope.markVisitedPage();
				}
				$rootScope.checkInternet($rootScope.selectedLang);
				$(tempVisited).addClass("visited");
				$rootScope.openpopupType3 = false;
			};
			$scope.onNextBack = function (state) {
				$rootScope.checkInternet($rootScope.selectedLang);
				if (state == 'back') {
					if ($rootScope.count < 2) {
						$rootScope.count = $rootScope.CourseContent.btn_click_learn.length;
						$rootScope.ButtontextType3 = $rootScope.CourseContent.btn_click_learn[$rootScope.count - 1].text;
					} else {
						$rootScope.count--;
						$rootScope.ButtontextType3 = $rootScope.CourseContent.btn_click_learn[$rootScope.count - 1].text;
					}
				}
				else if (state == 'next') {
					if ($rootScope.count > $rootScope.CourseContent.btn_click_learn.length - 1) $rootScope.count = 0; //return;;
					$rootScope.count++;
					$rootScope.ButtontextType3 = $rootScope.CourseContent.btn_click_learn[$rootScope.count - 1].text;
				}
				var flag = $('.clickables');
				if (!$(flag[0]).hasClass("markCompleted"))
					$(flag[0]).addClass("markCompleted");
				$(flag[$rootScope.count - 1]).removeClass("markCompleted");
				$(tempVisit).addClass("markCompleted");
				tempVisit = $(flag[$rootScope.count - 1]);
				$scope.active = $rootScope.count;
				$scope.checkCompletion($rootScope.count - 1);
				if ($rootScope.clickCounter.indexOf(0) == -1) {
					$rootScope.clickCounter.push(0);
				}
				if ($rootScope.count >= $rootScope.CourseContent.btn_click_learn.length)
					$rootScope.markVisitedPage();
			}
			$scope.checkCompletion = function (_val) {

				if ($rootScope.clickCounter.indexOf(_val) == -1)
					$rootScope.clickCounter.push(_val)
				console.log($rootScope.clickCounter.length + " == " + $rootScope.CourseContent.btn_click_learn.length)
				if ($rootScope.clickCounter.length == $rootScope.CourseContent.btn_click_learn.length) {
					$rootScope.showPopUp = true;
					if (track == false) {

					} else {
						$rootScope.markVisitedPage();
					}
				}

				//console.log($rootScope.clickCounter)
				/* if($rootScope.CourseContent.btn_click_learn.length == undefined)
					$rootScope.markVisitedPage(); */
			};

			/* if($rootScope.clickCounter.indexOf($scope.count-1) == -1)
				$rootScope.clickCounter.push($scope.count-1) */
		}
	}
});




FrameworkApp.directive('btnClickType30', function () {
	var tempVisited = '';

	return {
		restrict: 'CA',
		link: function ($scope, $rootScope, elem, attrs) {
			tempVisited = '';
		},
		controller: function ($scope, $rootScope, $timeout, $interval) {
			$rootScope.showPopUp = false;
			if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == "1") {
				$(".btnClickType30").addClass("visited");
				$rootScope.showPopUp = true;
				$scope.visitedStts = true;
				/* if($rootScope.isPassed[4] == 0 && $rootScope.currentTopic == 5 && ($rootScope.currentPage == 3 || $rootScope.currentPage == 4)){
					$rootScope.isNextButtonDisabled = true;
					$(".btnClickType3").removeClass("visited");
				} */
			}
			var tempVisit = '';
			var counter = 0;
			$rootScope.clicked = false;
			$rootScope.openpopupType3 = false;
			$scope.active = 1;
			$rootScope.count = 1;
			$scope.tCount = 0;
			$rootScope.clickCounter = [];
			$(".accordian-panel").hide();
			$rootScope.ButtontextType3 = '';
			var track = true;
			$scope.loadcontent = function (event, pItem, _type, tracking) {
				if (tracking)
					track = tracking;
				$rootScope.checkInternet($rootScope.selectedLang);
				$rootScope.openpopupType3 = true;
				$(".accordian-panel").show();
				$rootScope.count = parseInt(pItem.id);
				//$(tempVisited).addClass("selected");
				var flag = $('.clickables');
				if (!$(flag[0]).hasClass("markCompleted"))
					$(flag[0]).addClass("markCompleted");
				$(flag[pItem.id - 1]).removeClass("markCompleted");
				$(tempVisit).addClass("markCompleted");
				tempVisit = $(flag[pItem.id - 1]);
				$(".btnClickType30").removeClass("selected");
				$($(".btnClickType30")[$rootScope.count - 1]).addClass("selected");
				$rootScope.ButtontextType3 = pItem.text;
				$rootScope.clicked = true;
				$scope.checkCompletion($rootScope.count - 1);
				tempVisited = $(event.currentTarget);
				/* if($rootScope.clickCounter.length > 0){ */
				$(tempVisited).addClass("visited");
				/* } */
				if (_type === "cType") {
					if ($rootScope.clickCounter.indexOf(0) == -1) {
						$rootScope.clickCounter.push(0);
					}
				}

			}
			$rootScope.close = function (val) {
				// Temp code
				if (val == 'exit') {
					$rootScope.markVisitedPage();
				}
				$rootScope.checkInternet($rootScope.selectedLang);
				$(tempVisited).addClass("visited");
				$rootScope.openpopupType3 = false;
			};
			$scope.onNextBack = function (state) {
				$rootScope.checkInternet($rootScope.selectedLang);
				if (state == 'back') {
					if ($rootScope.count < 2) {
						$rootScope.count = $rootScope.CourseContent.btn_click_learn.length;
						$rootScope.ButtontextType3 = $rootScope.CourseContent.btn_click_learn[$rootScope.count - 1].text;
					} else {
						$rootScope.count--;
						$rootScope.ButtontextType3 = $rootScope.CourseContent.btn_click_learn[$rootScope.count - 1].text;
					}
				}
				else if (state == 'next') {
					if ($rootScope.count > $rootScope.CourseContent.btn_click_learn.length - 1) $rootScope.count = 0; //return;;
					$rootScope.count++;
					$rootScope.ButtontextType3 = $rootScope.CourseContent.btn_click_learn[$rootScope.count - 1].text;
				}
				var flag = $('.clickables');
				if (!$(flag[0]).hasClass("markCompleted"))
					$(flag[0]).addClass("markCompleted");
				$(flag[$rootScope.count - 1]).removeClass("markCompleted");
				$(tempVisit).addClass("markCompleted");
				tempVisit = $(flag[$rootScope.count - 1]);
				$scope.active = $rootScope.count;
				$scope.checkCompletion($rootScope.count - 1);
				if ($rootScope.clickCounter.indexOf(0) == -1) {
					$rootScope.clickCounter.push(0);
				}
				if ($rootScope.count >= $rootScope.CourseContent.btn_click_learn.length)
					$rootScope.markVisitedPage();
			}
			$scope.checkCompletion = function (_val) {

				if ($rootScope.clickCounter.indexOf(_val) == -1)
					$rootScope.clickCounter.push(_val)
				console.log($rootScope.clickCounter.length + " == " + $rootScope.CourseContent.btn_click_learn.length)
				if ($rootScope.clickCounter.length == $rootScope.CourseContent.btn_click_learn.length) {
					$rootScope.showPopUp = true;
					if (track == false) {

					} else {
						$rootScope.markVisitedPage();
					}
				}

				//console.log($rootScope.clickCounter)
				/* if($rootScope.CourseContent.btn_click_learn.length == undefined)
					$rootScope.markVisitedPage(); */
			};

			/* if($rootScope.clickCounter.indexOf($scope.count-1) == -1)
				$rootScope.clickCounter.push($scope.count-1) */
		}
	}
});
FrameworkApp.directive('conversationp14', function () {
	return {
		restrict: 'A',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope, $timeout, $interval) {
			var count = 0;
			var cnvrnTimer = null;
			var isPlaying = false;
			var sbBtClcked = [];
			$scope.isPlaying = isPlaying;
			$scope.visitedArray = [];
			$scope.c = 0;
			$scope.subPopup = false;
			$scope.showSbPP = false;
			$scope.disableOpt = false;
			$scope.disableClose = true;
			$scope.page1 = true;
			$scope.openHotword = false;
			$scope.showRetry = false;
			$scope.hotwordText = '';
			$scope.popupText = '';
			$scope.checkState = function (i) {
				//checkTime();
				if (i > $scope.c && $scope.visitedArray.indexOf(i) == -1 && $rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == "0") {
					return "disabled";
				}
				if (i == $scope.c) {
					return "activebtn";
				}
			};
			var timer;
			$timeout.cancel(timer);
			function checkTime(_val) {
				timer = $timeout(function () {
					console.log("----------" + _val)
					$($('.nav-btns')[_val + 1]).removeClass('disabled');
				}, 2000);
			}
			//checkTime($scope.c);

			function startScreen() {
				cnvrnTimer = $interval(function () {
					count++;
					var getTime = $rootScope.CourseContent.screen[$scope.c].timer ? $rootScope.CourseContent.screen[$scope.c].timer : 2;
					getTime = parseInt(getTime);
					var isSubBtn = $rootScope.CourseContent.screen[$scope.c].subBtn;
					if (isSubBtn) {
						$scope.isPlaying = false;
						isPlaying = false;
						$interval.cancel(cnvrnTimer);
					}
					if ($scope.visitedArray.indexOf($scope.c) == -1)
						$scope.visitedArray.push($scope.c);
					if (count >= getTime && !isSubBtn) {
						$('.speach-bubble').fadeOut(300, function () {
							$scope.c++;
							$scope.$apply();
							$('.speach-bubble').fadeIn(500);
						});
						sbBtClcked = [];
						$scope.showSbPP = false;
						if ($scope.c >= $rootScope.CourseContent.screen.length)
							$scope.c = 0;
						count = 0;
					}
					chkCompletion();
				}, 1000);
			}

			$scope.getcCntent = function (i) {
				if (!$rootScope.CourseContent.screen[0].subBtn && $scope.visitedArray.indexOf(0) == -1)
					$scope.visitedArray.push(0);
				$('.speach-bubble').fadeOut(300, function () {
					$scope.c = i;
					$timeout.cancel(timer);
					if (!$rootScope.CourseContent.screen[i].subBtn)
						checkTime($scope.c);
					$scope.$apply();
					$('.speach-bubble').fadeIn(500);
				});
				var isSubBtn = $rootScope.CourseContent.screen[i].subBtn;
				count = 0;

				if (isSubBtn) {
					$scope.isPlaying = false;
					isPlaying = false;
					$interval.cancel(cnvrnTimer);
				}
				if ($scope.visitedArray.indexOf(i) == -1 && !isSubBtn)
					$scope.visitedArray.push(i);
				chkCompletion();
				$scope.showSbPP = false;
				$scope.subPopup = false;

			}

			function chkCompletion() {
				var isCompleted = $scope.visitedArray.length >= $rootScope.CourseContent.screen.length;

				if (isCompleted) {
					$rootScope.markVisitedPage();
					$scope.isPlaying = false;
					isPlaying = false;
					return true;
				} else {
					return false;
				}
			}

			$scope.openSubPopup = function (ind, item, isObj) {
				$scope.disableClose = true;
				if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] != "1") {
					timer1 = $timeout(function () {
						$scope.disableClose = false;
					}, 3000);
				} else {
					$scope.disableClose = false;
				}
				$(event.currentTarget).addClass("selected-answer");
				$scope.subPopup = true;
				$scope.popupText = item.popupText;
				var sbBtnCnt = $rootScope.CourseContent.screen[$scope.c].subBtn;
				sbBtnCnt = parseInt(sbBtnCnt);
				if (sbBtClcked.indexOf(ind) == -1)
					sbBtClcked.push(ind);
				if (sbBtClcked.length >= sbBtnCnt) {
					if ($scope.visitedArray.indexOf($scope.c) == -1)
						$scope.visitedArray.push($scope.c);
					checkTime($scope.c);
				}
				chkCompletion();
			};

			$scope.closeSub = function () {
				$scope.subPopup = false;
				var isSubBtn = $rootScope.CourseContent.screen[$scope.c].subBtn;
				var sbBtnCnt = $rootScope.CourseContent.screen[$scope.c].subBtn;
				sbBtnCnt = parseInt(sbBtnCnt);
			};


			$scope.hotword = function (key, id, itemNum) {
				$scope.disableClose = true;
				if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] != "1") {
					timer1 = $timeout(function () {
						$scope.disableClose = false;
					}, 3000);
				} else {
					$scope.disableClose = false;
				}
				$scope.openHotword = true;
				$scope.hotwordText = $rootScope.CourseContent[key];
				if (itemNum) {
					var sbBtnCnt = $rootScope.CourseContent.screen[itemNum].subBtn;
				} else {
					var sbBtnCnt = $rootScope.CourseContent.screen[$scope.c].subBtn;
				}
				sbBtnCnt = parseInt(sbBtnCnt);
				if (sbBtClcked.indexOf(id) == -1)
					sbBtClcked.push(id);
				if (sbBtClcked.length >= sbBtnCnt) {
					if (itemNum) {
						if ($scope.visitedArray.indexOf(itemNum) == -1)
							$scope.visitedArray.push(itemNum);
						checkTime($scope.c);
					}
					else if ($scope.visitedArray.indexOf($scope.c) == -1)
						$scope.visitedArray.push($scope.c);
					checkTime($scope.c);
					chkCompletion();
				}
			}

			$scope.closeHotword = function (key) {
				$scope.openHotword = false;
				$scope.hotwordText = '';
			};
			var currentAttempt = 0;
			$scope.sbPop = function () {
				$scope.disableClose = true;
				if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] != "1") {
					timer1 = $timeout(function () {
						$scope.disableClose = false;
					}, 3000);
				} else {
					$scope.disableClose = false;
				}
				currentAttempt++;
				var maxAttempt = $rootScope.CourseContent.screen[$scope.c].maxAttempt || 1;
				var isSelectedCorrect = $(event.currentTarget).hasClass('correct-ans');
				if (isSelectedCorrect || currentAttempt >= maxAttempt) {
					$(event.currentTarget).addClass("selected-answer");
					$scope.showSbPP = true;
					$scope.disableOpt = true;
					if ($scope.visitedArray.indexOf($scope.c) == -1) {
						$scope.visitedArray.push($scope.c);
						checkTime($scope.c);
					}
					chkCompletion();
				} else {
					$scope.showRetry = true;
					$(event.currentTarget).parent().children().addClass('disabled');
				}

			}

			$scope.tryAgain = function () {
				$scope.showRetry = false;
				$('.lst-wrapper').find('li').removeClass('disabled');
			};

			$scope.closeSbPop = function () {
				$scope.showSbPP = false;
			};

			$scope.$on('$destroy', function () {
				$interval.cancel(cnvrnTimer)
				$timeout.cancel(timer);
			});
		}
	}
});

FrameworkApp.directive('carouselNav112', function () {
	return {
		restrict: 'C',
		link: function ($scope, $rootScope, $timeout, elem, attrs) {
		},
		controller: function ($scope, $rootScope) {

			$('#myCarousel').carousel({
				wrap: false
			});
			if ($rootScope.isPassed[4] == 0 && $rootScope.currentPage == 2 && $rootScope.currentTopic == 5) {
				$rootScope.isNextButtonDisabled = true;
			}
			$rootScope.popup16Closed = true;
			$rootScope.popup16_viewed = false;
			$rootScope.popup161_viewed = false;

			$rootScope.popup161Closed = true;
			$rootScope.popup162_viewed = false;
			$scope.counter = 0;
			$scope.clickCounter = [];
			$scope.clickCounter.push(0);
			/* 	setTimeout(function(){
					if($rootScope.CourseContent.subBtns == true || $rootScope.CourseContent.subBtns == "true"){
						
					}else{
						if($scope.clickCounter.indexOf(0) == -1)
							$scope.clickCounter.push(0);
							$scope.$apply();
					}
				},500); */

			var _hyperLink = false;
			var subBtn = 0;
			$scope.additionalpopupToggle = false;

			$scope.playVideo = function (_id) {
				$scope.showSkipVideo = true;
				if (_id) {
					document.getElementById(_id).play();
				} else {
					vdo.play();
				}
				$scope.showPlayBtn = false;
				$(".audio-btn").addClass("disablePlay");
				/* $(".replayBtn").addClass("disablePlay"); */
			};

			$scope.navigatePage = function (nav) {

				$rootScope.checkInternet($rootScope.selectedLang);
				if (nav == 'next') {
					$('#myCarousel').carousel("next");
					$scope.counter++;
					if ($scope.counter == 4) {
						$scope.additionalpopupToggle = true;
					}
					var _ele = $('.carousel-indicators').find('li');
					$(_ele[$scope.counter + 1]).removeClass('disabled');
					console.log($scope.counter)
					$(_ele[$scope.counter - 1]).addClass('visited');
					//if($scope.counter == $rootScope.CourseContent.btn_content.length-1){
					$(_ele[$scope.counter]).addClass('visited');
					//}
				} else {
					$('#myCarousel').carousel("prev");
					$scope.counter--;
				}
				if ($scope.counter > 0) {
					setTimeout(function () {
						$('.left').css("pointer-events", "all");
					}, 800);
					$('.left').css("opacity", "1");
				} else {
					$('.left').css("pointer-events", "none");
					$('.left').css("opacity", "0.5");
				}

				if ($rootScope.CourseContent.btn_content.length == $scope.counter + 1) {
					$('.right').css("pointer-events", "none");
					$('.right').css("opacity", "0.5");
				} else {
					setTimeout(function () {
						$('.right').css("pointer-events", "all");
					}, 800);
					$('.right').css("opacity", "1");
				}
				var sbBtns = $rootScope.CourseContent.btn_content[$scope.counter].sub_btn ? $rootScope.CourseContent.btn_content[$scope.counter].sub_btn : 0;
				if (parseInt(sbBtns) <= 0) {
					$scope.checkCompletion();
				}
				$(".right").css("pointer-events", "none");
				$(".left").css("pointer-events", "none");
				$(".item").css("pointer-events", "all");
				$(".item").removeClass("done");
				$(".item").removeClass("done");
			};

			$scope.trackBtns = function (_val) {
				if ($scope.clickCounter.indexOf(_val) == -1) {
					$scope.clickCounter.push(_val);
					$scope.checkCompletion();
				}
				if (_val == 0) {
					$('.left').css("pointer-events", "none");
					$('.left').css("opacity", "0.5");
				} else {
					$('.left').css("pointer-events", "all");
					$('.left').css("opacity", "1");
				}
				if (_val == $rootScope.CourseContent.btn_content.length - 1) {
					$('.right').css("pointer-events", "none");
					$('.right').css("opacity", "0.5");
				} else {
					$('.right').css("pointer-events", "all");
					$('.right').css("opacity", "1");
				}
				var _ele = $('.carousel-indicators').find('li');
				console.log(_ele)
				$(_ele[_val + 1]).removeClass('disabled');
				$(_ele[$scope.counter]).addClass('visited');
				$scope.counter = _val;
				$(_ele[$scope.counter]).addClass('visited');
				console.log(_val)
			};

			$scope.disableBtns = function (_val) {
				var status = '';
				if ($scope.clickCounter.length < _val && $rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == 0)
					status += 'disabled';
				else
					status += 'enabled';
				if (_val == $scope.counter)
					status += ' active';
				if ($scope.clickCounter[_val] != undefined || $rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == 1) {
					status += ' visited';
				}
				return status;
			};
			$scope.togglePopup16 = function () {
				$rootScope.popup16Closed = !$rootScope.popup16Closed;
				$rootScope.popup16_viewed = true;
				$scope.checkCompletion();
			}
			$scope.togglePopup161 = function () {
				// $rootScope.popup161Closed = !$rootScope.popup161Closed;
				$rootScope.popup16Closed = !$rootScope.popup16Closed;
				$rootScope.popup161_viewed = true;
				$scope.checkCompletion();
			}
			$scope.togglePopup162 = function () {
				// $rootScope.popup161Closed = !$rootScope.popup161Closed;
				if ($('video')[0] != undefined) {
					$('video')[0].currentTime = 0;
					$('video')[0].pause();
				}
				$rootScope.popup161Closed = !$rootScope.popup161Closed;
				$rootScope.popup162_viewed = true;
				$scope.checkCompletion();
			}
			$scope.checkCompletion = function () {
				if ($scope.clickCounter.indexOf($scope.counter) == -1) {
					$scope.clickCounter.push($scope.counter);
				}
				if ($scope.clickCounter.length == $rootScope.CourseContent.btn_content.length && $rootScope.popup16_viewed == true && $rootScope.popup161_viewed == true && $rootScope.popup162_viewed == true) {
					$rootScope.markVisitedPage();
					console.log($rootScope.CourseContent.markNextScreen)
					if ($rootScope.CourseContent.markNextScreen == "true")
						$rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage + 1] = "1";
					console.log($rootScope.pageStatusList[$rootScope.currentTopic])
				}
			}

		}
	}
});

FrameworkApp.directive('btnClickTypeCarouselInside209', function () {
	var counter = 0, count;
	return {
		restrict: 'C',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope) {
			$scope.counter = 0;

			$rootScope.popup16Closed = false

			$scope.completed = false;
			if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == "1") {
				$scope.completed = true;
				// $rootScope.markVisitedPage();
			}
			$(".accordian-panel").hide();
			//$rootScope.ButtonContent = $rootScope.CourseContent.btn_click_learn[0].button_content;
			$rootScope.showContent = true;
			//$(".btn-container li:first-child").addClass('clicked visited');
			$scope.loadcontent = function (event, pItem, id) {
				// debugger;
				$scope.counter = 0;
				$rootScope.c_id = "01";
				$rootScope.ButtonContent = null;
				$rootScope.ButtonContent = [];
				$(".accordian-panel").show();
				$rootScope.cid = pItem.id;
				$rootScope.index1 = $rootScope.cid
				console.log(typeof pItem.button_content.length)
				if (pItem.button_content.length == 1 || pItem.button_content.length == undefined) {
					$rootScope.c_id = "01";
				}
				else {
					if ($rootScope.index1 == undefined) {
						$rootScope.c_id = pItem.button_content[0].id;
					} else {
						$rootScope.index1 = 0;
						$rootScope.c_id = $rootScope.pad($rootScope.index1 + 1);
					}
				}
				$rootScope.showContent = false;
				$rootScope.idChecker = pItem;
				$rootScope.ButtonContent = pItem.button_content;
				if ($rootScope.ButtonContent.subId != undefined) {
					$rootScope.changeWidth_pp = $rootScope.ButtonContent.subId;
				}
				//	console.log($rootScope.ButtonContent.length);
				if (event != null) {
					if (pItem.button_content.length == undefined) {
						console.log(pItem.button_content.length)
						$rootScope.ButtonContent = [];
						$rootScope.ButtonContent[0] = pItem.button_content;
						//$rootScope.ButtonContent=Object.assign({}, pItem.button_content);
						//console.log($rootScope.ButtonContent.length);
						//console.log($rootScope.ButtonContent);
						$(".carousel-control").hide();
						$(".carousel-indicators").hide();

						if (pItem.click == "0") {
							$($(".btnClickTypeCarouselInside")[pItem.id - 1]).children("span").addClass("visited");
						}

					} else {
						// $($(".btnClickTypeCarouselInside")[pItem.id-1]).children("span").addClass("visited");
						$(".carousel-control").show();
						$(".carousel-indicators").show();
					}
				}
				/* $(".btnClickTypeCarouselInside1").removeClass("clicked");
				$(event.target).addClass("clicked"); */
				//$(event.target).children("span").addClass("visited");

				if ($(".visited").length == $(".btnClickTypeCarouselInside").length)
					$rootScope.markVisitedPage();
				$rootScope.index1 = pItem.id - 1;
				//console.log($scope.index )
				if ($rootScope.CourseContent.btn_click_learn[$rootScope.index1].button_content.length <= $scope.counter + 1) {
					$('.right').css("pointer-events", "none");
					$('.right').css("opacity", "0.5");
				} else {
					setTimeout(function () {
						$('.right').css("pointer-events", "all");
					}, 800);
					$('.right').css("opacity", "1");
				}
				$(".carousel-indicators").find('.active').addClass("scenario");
				if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == '0' && $rootScope.CourseContent.isNextButtonDisabled == 'true') {
					$rootScope.isNextButtonDisabled = true;
				}

			};
			$scope.close = function () {
				if ($rootScope.idChecker.id == 1 || $rootScope.idChecker.id == '1') {
					if ($('#checkVisited').hasClass('visited')) {
						$($(".btnClickTypeCarouselInside")[0]).children("span").addClass("visited");
					}
					if ($(".visited").length >= $(".btnClickTypeCarouselInside").length) {
						$rootScope.markVisitedPage();
					}
				}
				// $scope.loadcontent(null,$rootScope.CourseContent.btn_click_learn[0]);
				$rootScope.showContent = true;
				// $rootScope.c_id = "01"
			}


			$scope.togglePopup161 = function () {
				// $rootScope.popup161Closed = !$rootScope.popup161Closed;
				$rootScope.popup16Closed = $rootScope.popup16Closed ? false : true

				$($(".btnClickTypeCarouselInside")[$rootScope.index1]).children("span").addClass("visited");
                 $("#checkVisited").addClass('visited1')
				if ($(".visited").length == $(".btnClickTypeCarouselInside").length)
					$rootScope.markVisitedPage();

			}
			$scope.buttonNavigation = function (event, pItem) {
				$rootScope.c_id = pItem.id;
				$(".carousel-indicators").find('.active').addClass("scenario");
				if ($(".carousel-indicators").find('li').length - 1 == $(".scenario").length)
					$($(".btnClickTypeCarouselInside")[$rootScope.index1]).children("span").addClass("visited");
				//console.log($(".visited").length+"__"+$(".btnClickTypeCarouselInside").length)
				if ($(".visited").length == $(".btnClickTypeCarouselInside").length)
					$rootScope.markVisitedPage();
			};
			$scope.navigatePage = function (nav) {

				$rootScope.checkInternet($rootScope.selectedLang);
				if (nav == 'next') {
					// $($(".btnClickTypeCarouselInside")[Number($rootScope.index1)]).children("span").addClass("visited");
					// $($(".btnClickTypeCarouselInside")[$rootScope.index]).children("span").addClass("visited");
					$('#myCarousel').carousel("next");
					$scope.counter++;
					if ($scope.counter == 4) {
						$scope.additionalpopupToggle = true;
					}
					var _ele = $('.carousel-indicators').find('li');
					$(_ele[$scope.counter + 1]).removeClass('disabled');
					console.log($scope.counter)
					$(_ele[$scope.counter - 1]).addClass('visited');
					if ($scope.counter == $rootScope.CourseContent.btn_click_learn[$rootScope.index1].button_content.length - 1) {
						$($(".btnClickTypeCarouselInside")[$rootScope.index1]).children("span").addClass("visited");
					}
				} else {
					$('#myCarousel').carousel("prev");
					$scope.counter--;
				}
				if ($scope.counter > 0) {
					setTimeout(function () {
						$('.left').css("pointer-events", "all");
					}, 800);
					$('.left').css("opacity", "1");
				} else {
					$('.left').css("pointer-events", "none");
					$('.left').css("opacity", "0.5");
				}

				if ($rootScope.CourseContent.btn_click_learn[$rootScope.index1].button_content.length <= $scope.counter + 1) {
					$('.right').css("pointer-events", "none");
					$('.right').css("opacity", "0.5");
				} else {
					setTimeout(function () {
						$('.right').css("pointer-events", "all");
					}, 800);
					$('.right').css("opacity", "1");
				}
				// var sbBtns = $rootScope.CourseContent.btn_content[$scope.counter].sub_btn ? $rootScope.CourseContent.btn_content[$scope.counter].sub_btn : 0;
				// if (parseInt(sbBtns) <= 0) {
				// 	$scope.checkCompletion();
				// }
				$(".right").css("pointer-events", "none");
				$(".left").css("pointer-events", "none");
				$(".item").css("pointer-events", "all");
				$(".item").removeClass("done");
				$(".item").removeClass("done");
				if ($(".visited").length == $(".btnClickTypeCarouselInside").length)
					$rootScope.markVisitedPage();
			};
		}
	}
});



FrameworkApp.directive('btnClickTypeCarouselInsidemodsix', function () {
	var counter = 0, count;
	return {
		restrict: 'C',
		link: function ($scope, $rootScope, elem, attrs) {
		},
		controller: function ($scope, $rootScope) {
			$rootScope.popup16Closed = false;
			$scope.counter = 0;
			if (counter = count) {
				$rootScope.markVisitedPage();
			}
			$scope.completed = false;
			if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == "1") {
				$scope.completed = true;
				$rootScope.markVisitedPage();
			}
			$(".accordian-panel").hide();
			//$rootScope.ButtonContent = $rootScope.CourseContent.btn_click_learn[0].button_content;
			$rootScope.showContent = true;
			//$(".btn-container li:first-child").addClass('clicked visited');
			$scope.loadcontent = function (event, pItem, id) {
				// debugger;
				$scope.counter = 0;
				$rootScope.c_id = "01";
				$rootScope.ButtonContent = null;
				$rootScope.ButtonContent = [];
				$(".accordian-panel").show();
				$rootScope.cid = pItem.id;
				console.log(typeof pItem.button_content.length)
				if (pItem.button_content.length == 1 || pItem.button_content.length == undefined) {
					$rootScope.c_id = "01";
				}
				else {
					if ($rootScope.index1 == undefined) {
						$rootScope.c_id = pItem.button_content[0].id;
					} else {
						$rootScope.index1 = 0;
						$rootScope.c_id = $rootScope.pad($rootScope.index1 + 1);
					}
				}
				$rootScope.showContent = false;
				$rootScope.idChecker = pItem;
				$rootScope.ButtonContent = pItem.button_content;
				if ($rootScope.ButtonContent.subId != undefined) {
					$rootScope.changeWidth_pp = $rootScope.ButtonContent.subId;
				}
				//	console.log($rootScope.ButtonContent.length);
				if (event != null) {
					if (pItem.button_content.length == undefined) {
						console.log(pItem.button_content.length)
						$rootScope.ButtonContent = [];
						$rootScope.ButtonContent[0] = pItem.button_content;
						//$rootScope.ButtonContent=Object.assign({}, pItem.button_content);
						//console.log($rootScope.ButtonContent.length);
						//console.log($rootScope.ButtonContent);
						$(".carousel-control").hide();
						$(".carousel-indicators").hide();
						if (pItem.click == "0")
							$($(".btnClickTypeCarouselInside")[pItem.id - 1]).children("span").addClass("visited");


					} else {
						// $($(".btnClickTypeCarouselInside")[pItem.id-1]).children("span").addClass("visited");
						$(".carousel-control").show();
						$(".carousel-indicators").show();
					}
				}
				/* $(".btnClickTypeCarouselInside1").removeClass("clicked");
				$(event.target).addClass("clicked"); */
				//$(event.target).children("span").addClass("visited");
				if ($(".visited").length >= $(".btnClickTypeCarouselInside").length) {
					$rootScope.markVisitedPage();
				}
				$rootScope.index1 = pItem.id - 1;
				//console.log($scope.index )
				if ($rootScope.CourseContent.btn_click_learn[1].button_content.length <= $scope.counter + 1) {
					$('.right').css("pointer-events", "none");
					$('.right').css("opacity", "0.5");
				} else {
					setTimeout(function () {
						$('.right').css("pointer-events", "all");
					}, 800);
					$('.right').css("opacity", "1");
				}
				$(".carousel-indicators").find('.active').addClass("scenario");
				if ($rootScope.pageStatusList[$rootScope.currentTopic][$rootScope.currentPage] == '0' && $rootScope.CourseContent.isNextButtonDisabled == 'true') {
					$rootScope.isNextButtonDisabled = true;
				}

			};


			$scope.togglePopup166 = function () {
				$rootScope.popup16Closed = $rootScope.popup16Closed ? false : true;
				if ($rootScope.popup16Closed == true) {
					$('#checkVisited').addClass('sc-visited');
				}

				if ($(".visited").length >= $(".btnClickTypeCarouselInside").length)
					$rootScope.markVisitedPage();
				$($(".btnClickTypeCarouselInside")[$rootScope.index1]).children("span").addClass("visited");
				// $rootScope.popup16_viewed = true;
				// $scope.checkCompletion();
			}

			$scope.close = function () {

				if ($(".visited").length >= $(".btnClickTypeCarouselInside").length) {
					$rootScope.markVisitedPage();
				}

				// $scope.loadcontent(null,$rootScope.CourseContent.btn_click_learn[0]);
				$rootScope.showContent = true;
				// $rootScope.isNextButtonDisabled = false;
				// $rootScope.c_id = "01"
			}
			$scope.buttonNavigation = function (event, pItem) {
				$rootScope.c_id = pItem.id;
				$(".carousel-indicators").find('.active').addClass("scenario");
				if ($(".carousel-indicators").find('li').length - 1 == $(".scenario").length)
					$($(".btnClickTypeCarouselInside")[$rootScope.index1]).children("span").addClass("visited");
				//console.log($(".visited").length+"__"+$(".btnClickTypeCarouselInside").length)
				if ($(".visited").length == $(".btnClickTypeCarouselInside").length)
					$rootScope.markVisitedPage();
			};
			$scope.navigatePage = function (nav) {

				$rootScope.checkInternet($rootScope.selectedLang);
				if (nav == 'next') {
					$($(".btnClickTypeCarouselInside")[1]).children("span").addClass("visited");
					$('#myCarousel').carousel("next");
					$scope.counter++;
					if ($scope.counter == 4) {
						$scope.additionalpopupToggle = true;
					}
					var _ele = $('.carousel-indicators').find('li');
					$(_ele[$scope.counter + 1]).removeClass('disabled');
					console.log($scope.counter)
					$(_ele[$scope.counter - 1]).addClass('visited');
					//if($scope.counter == $rootScope.CourseContent.btn_content.length-1){
					$(_ele[$scope.counter]).addClass('visited');
					//}
				} else {
					$('#myCarousel').carousel("prev");
					$scope.counter--;
				}
				if ($scope.counter > 0) {
					setTimeout(function () {
						$('.left').css("pointer-events", "all");
					}, 800);
					$('.left').css("opacity", "1");
				} else {
					$('.left').css("pointer-events", "none");
					$('.left').css("opacity", "0.5");
				}

				if ($rootScope.CourseContent.btn_click_learn[1].button_content.length <= $scope.counter + 1) {
					$('.right').css("pointer-events", "none");
					$('.right').css("opacity", "0.5");
				} else {
					setTimeout(function () {
						$('.right').css("pointer-events", "all");
					}, 800);
					$('.right').css("opacity", "1");
				}
				var sbBtns = $rootScope.CourseContent.btn_content[$scope.counter].sub_btn ? $rootScope.CourseContent.btn_content[$scope.counter].sub_btn : 0;
				if (parseInt(sbBtns) <= 0) {
					$scope.checkCompletion();
				}
				$(".right").css("pointer-events", "none");
				$(".left").css("pointer-events", "none");
				$(".item").css("pointer-events", "all");
				$(".item").removeClass("done");
				$(".item").removeClass("done");
				if ($(".visited").length == $(".btnClickTypeCarouselInside").length)
					$rootScope.markVisitedPage();
			};
		}
	}
});